//================================================================================================
//
// 定数定義
//
//================================================================================================

// オートスペル設定　最大数
AUTO_SPELL_SETTING_COUNT = 20;


// オートスペル系スキル　最大数
AUTO_SPELL_SKILL_COUNT_MAX = 40;


// オートスペル発動率（千分率）
AUTO_SPELL_PROB_ARRAY = [
	0
	,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10
	,  15,  20,  25,  30,  40,  50,  60,  70,  80,  90
	, 100, 120, 140, 150, 160, 180, 200, 250, 300, 350
	, 400, 450, 500, 550, 600, 650, 700, 750, 800, 850
	, 900, 950,1000
];



//================================================================================================
//
// グローバル変数定義
//
//================================================================================================

n_AS_SKILL = new Array();

n_AS_DMG = new Array();
n_AS_DMG_OverHP = new Array();
for (var idx = 0; idx < AUTO_SPELL_SKILL_COUNT_MAX; idx++) {
	n_AS_DMG[idx] = new Array();
	n_AS_DMG_OverHP[idx] = new Array();
}





//================================================================================================
//
// 処理
//
//================================================================================================

/**
 * オートスペルの計算.
 */
function AS_Calc(){

	// 初期化
	for (var idx = 0; idx < AUTO_SPELL_SKILL_COUNT_MAX; idx++){
		n_AS_DMG[idx][0] = 0;
		n_AS_DMG[idx][1] = 0;
		n_AS_DMG[idx][2] = 0;
		n_AS_DMG_OverHP[idx][0] = 0;
		n_AS_DMG_OverHP[idx][1] = 0;
		n_AS_DMG_OverHP[idx][2] = 0;
		n_AS_SKILL[idx] = new Array();
		n_AS_SKILL[idx][0] = -1;
	}

	var idx=0;

	//----------------------------------------------------------------
	// 三段掌
	//----------------------------------------------------------------
	var wAS_3dan = 0;
	if(SkillSearch(187)) wAS_3dan = wBC3_3danHatudouRitu;


	//----------------------------------------------------------------
	// 通常攻撃時の、デュプレライト追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 && n_Enekyori == 0 && SkillSearch(492)){
		n_AS_SKILL[idx][0] = 741;
		n_AS_SKILL[idx][1] = SkillSearch(492);
		n_AS_SKILL[idx][2] = 5 * SkillSearch(492) * 10;
		if(wAS_3dan > 0) n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] * (100 - wAS_3dan) / 100;
		n_AS_SKILL[idx][3] = 0;
		idx++;
		n_AS_SKILL[idx][0] = 742;
		n_AS_SKILL[idx][1] = SkillSearch(492);
		n_AS_SKILL[idx][2] = 5 * SkillSearch(492) * 10;
		if(wAS_3dan > 0) n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] * (100 - wAS_3dan) / 100;
		n_AS_SKILL[idx][3] = 0;
		idx++;
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、オートシャドウスペル追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 && n_Enekyori == 0 && SkillSearch(596) && SkillSearch(747) != 0){

		var wASS = [0,51,52 ,53,54,55,56,57,46,47,125,126,127,128,130,131,132,133,102,104];
		n_AS_SKILL[idx][0] = wASS[SkillSearch(747)];
		n_AS_SKILL[idx][1] = ROUNDDOWN((SkillSearch(596)+1) / 2);
		var ritu = [0,26,28,24,26,22,24,20,22,18,20];
		n_AS_SKILL[idx][2] = ritu[SkillSearch(596)] * 10;
		if(wAS_3dan > 0) n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] * (100 - wAS_3dan) / 100;
		n_AS_SKILL[idx][3] = 0;
		idx++;
		if(n_AS_SKILL[idx-1][0] == 51 || n_AS_SKILL[idx-1][0] == 54 || n_AS_SKILL[idx-1][0] == 56){
			if(TimeItemNumSearch(76)){
				n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
				n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
				n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * 40 * 10 / 100;
				n_AS_SKILL[idx][3] = 0;
				idx++;
			}
		}
	}


	//----------------------------------------------------------------
	// ビーストストレイフィング時の、ダブルストレイフィング追撃あり時の効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 391 && eval(document.calcForm.SkillSubNum.value) == 1){
		n_AS_SKILL[idx][0] = 40;
		n_AS_SKILL[idx][1] = 10;
		n_AS_SKILL[idx][2] = 100;
		n_AS_SKILL[idx][3] = -2;
		idx++;
	}


	//----------------------------------------------------------------
	// ハンドレッドスピア時の、スピアブーメラン追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 442 && eval(document.calcForm.SkillSubNum2.value) >= 1){
		n_AS_SKILL[idx][0] = 72;
		n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
		n_AS_SKILL[idx][2] = (10 + 3 * n_A_ActiveSkillLV) * 10;
		n_AS_SKILL[idx][3] = 0;
		idx++;
	}


	//----------------------------------------------------------------
	// ダークイリュージョン時の、クロスインパクト追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 461 && eval(document.calcForm.SkillSubNum.value) >= 1){
		n_AS_SKILL[idx][0] = 460;
		n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
		n_AS_SKILL[idx][2] = (30 - 5 * n_A_ActiveSkillLV) * 10;
		n_AS_SKILL[idx][3] = 0;
		idx++;
	}


	//----------------------------------------------------------------
	// パワースイング時の、アックスブーメラン追撃効果
	//----------------------------------------------------------------
	if(n_A_WeaponType == 6 || n_A_WeaponType == 7){
		if(n_A_ActiveSkill == 543 && eval(document.calcForm.SkillSubNum.value) >= 1){
			n_AS_SKILL[idx][0] = 542;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
			n_AS_SKILL[idx][2] = 5 * n_A_ActiveSkillLV * 10;
			n_AS_SKILL[idx][3] = 0;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、ウォーグストライク追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 && SkillSearch(751)){
		n_AS_SKILL[idx][0] = 513;
		n_AS_SKILL[idx][1] = SkillSearch(751);
		n_AS_SKILL[idx][2] = n_A_LUK * 3;
		n_AS_SKILL[idx][3] = 0;
		idx++;
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、ブリッツビート追撃効果
	//----------------------------------------------------------------
	else if(n_A_ActiveSkill == 0 && n_A_WeaponType==10 && SkillSearch(118)){
		n_AS_SKILL[idx][0] = 118;
		var w1 = Math.floor((n_A_JobLV -1) / 10 +1);
		if(w1 > 5) w1 = 5;
		if(n_A_JOB != 10 && n_A_JOB != 24) w1 = 5;
		var w2 = SkillSearch(118);
		if(w2 <w1) w1 = w2;
		n_AS_SKILL[idx][1] = w1;
		n_AS_SKILL[idx][2] = 10 + n_A_LUK * 3;
		n_AS_SKILL[idx][3] = 10;
		idx++;
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、ブリッツビート追撃効果（装備セットによるもの）
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 && SkillSearch(118) && EquipNumSearch(2186) && SkillSearch(751) == 0){
		n_AS_SKILL[idx][0] = 118;
		n_AS_SKILL[idx][1] = SkillSearch(118);
		var w9 = SU_LUK;
		if(w9 > 120) w9 = 120;
		n_AS_SKILL[idx][2] = (50 + w9 * 2) * SkillSearch(118) / 5;
		n_AS_SKILL[idx][3] = 11;
		idx++;
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、ブリッツビート追撃効果（装備セットによるもの）
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 && SkillSearch(118) && EquipNumSearch(2513) && SkillSearch(751) == 0){
		n_AS_SKILL[idx][0] = 118;
		n_AS_SKILL[idx][1] = SkillSearch(118);
		var w9 = SU_LUK;
		if(w9 > 120) w9 = 120;
		n_AS_SKILL[idx][2] = (50 + w9 * 2) * SkillSearch(118) / 5;
		n_AS_SKILL[idx][3] = 11;
		idx++;
	}


	//----------------------------------------------------------------
	// 「古びた迷彩ウサギフード」の、＋９以上精錬による、自動狼の発動
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 && SkillSearch(751)) {
		if (EquipNumSearch(ITEM_ID_FURUBITA_MEISAIUSAGI) && n_A_HEAD_DEF_PLUS >= 9){

			// 適用スキルの設定
			n_AS_SKILL[idx][0] = 513;

			// 適用レベルの設定
			n_AS_SKILL[idx][1] = SkillSearch(751);

			// 発動率の設定
			var w9 = SU_LUK;
			if(w9 > 120) w9 = 120;
			n_AS_SKILL[idx][2] = (50 + w9 * 2) * SkillSearch(751) / 5;

			// 表示組立部フラグの設定（通常は０）
			n_AS_SKILL[idx][3] = 0;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、クイックドロー追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0
		&& SkillSearch(SKILL_ID_AS_QUICKDRAW)
		&& (
			(n_A_WeaponType == ITEM_KIND_HANDGUN && SkillSearch(SKILL_ID_CHAIN_ACTION))
			||
			(ITEM_KIND_HANDGUN <= n_A_WeaponType && n_A_WeaponType <= ITEM_KIND_GRENADEGUN
				&& SkillSearch(SKILL_ID_ETERNAL_CHAIN))
		)
	) {

		// 適用スキルの設定
		n_AS_SKILL[idx][0] = SKILL_ID_QUICKDRAW_SHOT;

		// 適用レベルの設定
		n_AS_SKILL[idx][1] = 1;

		// 発動率の設定
		if (SkillSearch(SKILL_ID_ETERNAL_CHAIN)) {
			// エターナルチェーンの場合
			n_AS_SKILL[idx][2] = 5 * SkillSearch(SKILL_ID_ETERNAL_CHAIN) * 10;
		}
		else {
			// チェーンアクションの場合
			n_AS_SKILL[idx][2] = 5 * SkillSearch(SKILL_ID_CHAIN_ACTION) * 10;
		}

		// 表示組立部フラグの設定（通常は０）
		n_AS_SKILL[idx][3] = 0;
		idx++;
	}


	//----------------------------------------------------------------
	// 鋭敏な嗅覚時の、ウォーグバイト追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 514 && eval(document.calcForm.SkillSubNum.value) >= 1){
		n_AS_SKILL[idx][0] = 511;
		n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
		n_AS_SKILL[idx][2] = 8 * n_A_ActiveSkillLV * 10;
		n_AS_SKILL[idx][3] = 0;
		idx++;
	}


	//----------------------------------------------------------------
	// ヘスペルスリット時の、ピンポイントアタック追撃効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 586){
		var w = 1;
		if(SkillSearch(587)) w += 2;
		if((SkillSearch(754) + w) == 6){
			n_AS_SKILL[idx][0] = 574;
			n_AS_SKILL[idx][1] = 1;
			n_AS_SKILL[idx][2] = 100;
			n_AS_SKILL[idx][3] = -3;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// 閃光連撃時の、連撃
	//----------------------------------------------------------------
	if(n_A_ActiveSkill==799){
		if(eval(document.calcForm.SkillSubNum.value) != 0){
			n_AS_SKILL[idx][0] = 609;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
		if(eval(document.calcForm.SkillSubNum2.value) != 0){
			n_AS_SKILL[idx][0] = 614;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
		if(eval(document.calcForm.SkillSubNum3.value) != 0){
			n_AS_SKILL[idx][0] = 615;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum3.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
		if(eval(document.calcForm.SkillSubNum4.value) != 0){
			n_AS_SKILL[idx][0] = 610;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum4.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// 三段コンボ時の、連撃
	//----------------------------------------------------------------
	if(n_A_ActiveSkill==800 || n_A_ActiveSkill==801){
		n_AS_SKILL[idx][0] = 187;
		n_AS_SKILL[idx][1] = SkillSearch(187);
		n_AS_SKILL[idx][2] = 1000;
		n_AS_SKILL[idx][3] = -4;
		idx++;
		if(eval(document.calcForm.SkillSubNum.value) != 0){
			n_AS_SKILL[idx][0] = 188;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
		if(eval(document.calcForm.SkillSubNum2.value) != 0){
			n_AS_SKILL[idx][0] = 189;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
		if(n_A_ActiveSkill==800){
			if(eval(document.calcForm.SkillSubNum3.value) != 0){
				n_AS_SKILL[idx][0] = 321;
				n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum3.value);
				n_AS_SKILL[idx][2] = 1000;
				n_AS_SKILL[idx][3] = -4;
				idx++;
			}
		}else{
			if(eval(document.calcForm.SkillSubNum3.value) != 0){
				n_AS_SKILL[idx][0] = 289;
				n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum3.value);
				n_AS_SKILL[idx][2] = 1000;
				n_AS_SKILL[idx][3] = -4;
				idx++;
			}
			if(eval(document.calcForm.SkillSubNum4.value) != 0){
				n_AS_SKILL[idx][0] = 290;
				n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum4.value);
				n_AS_SKILL[idx][2] = 1000;
				n_AS_SKILL[idx][3] = -4;
				idx++;
			}
			if(eval(document.calcForm.SkillSubNum5.value) != 0){
				n_AS_SKILL[idx][0] = 321;
				n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum5.value);
				n_AS_SKILL[idx][2] = 1000;
				n_AS_SKILL[idx][3] = -4;
				idx++;
			}
		}
	}


	//----------------------------------------------------------------
	// 双龍コンボ時の、連撃
	//----------------------------------------------------------------
	if(n_A_ActiveSkill==802){
		n_AS_SKILL[idx][0] = 609;
		n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
		n_AS_SKILL[idx][2] = 1000;
		n_AS_SKILL[idx][3] = -4;
		idx++;
		if(eval(document.calcForm.SkillSubNum2.value) != 0){
			n_AS_SKILL[idx][0] = 610;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}else{
			if(eval(document.calcForm.SkillSubNum3.value) != 0){
				n_AS_SKILL[idx][0] = 614;
				n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum3.value);
				n_AS_SKILL[idx][2] = 1000;
				n_AS_SKILL[idx][3] = -4;
				idx++;
			}
			if(eval(document.calcForm.SkillSubNum4.value) != 0){
				n_AS_SKILL[idx][0] = 615;
				n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum4.value);
				n_AS_SKILL[idx][2] = 1000;
				n_AS_SKILL[idx][3] = -4;
				idx++;
			}else{
				if(eval(document.calcForm.SkillSubNum5.value) != 0){
					n_AS_SKILL[idx][0] = 616;
					n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum5.value);
					n_AS_SKILL[idx][2] = 1000;
					n_AS_SKILL[idx][3] = -4;
					idx++;
				}
			}
		}
	}


	//----------------------------------------------------------------
	// ギガントセット　ジョイントコンボ時の、連撃
	//----------------------------------------------------------------
	if (n_A_ActiveSkill == SKILL_ID_COMBO_GIGANTSET_JOINT_BEAT) {
		n_AS_SKILL[idx][0] = SKILL_ID_JOINT_BEAT;
		n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum.value);
		n_AS_SKILL[idx][2] = 1000;
		n_AS_SKILL[idx][3] = -4;
		idx++;

		if (eval(document.calcForm.SkillSubNum2.value) != 0) {
			n_AS_SKILL[idx][0] = SKILL_ID_SPIRAL_PIERCE;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}

		if (eval(document.calcForm.SkillSubNum3.value) != 0) {
			n_AS_SKILL[idx][0] = SKILL_ID_SONIC_WAVE;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum3.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// ギガントセット　スパイラルコンボ時の、連撃
	//----------------------------------------------------------------
	if (n_A_ActiveSkill == SKILL_ID_COMBO_GIGANTSET_SPIRAL_PIERCE) {
		n_AS_SKILL[idx][0] = SKILL_ID_SPIRAL_PIERCE;
		n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
		n_AS_SKILL[idx][2] = 1000;
		n_AS_SKILL[idx][3] = -4;
		idx++;

		if(eval(document.calcForm.SkillSubNum2.value) != 0){
			n_AS_SKILL[idx][0] = SKILL_ID_SONIC_WAVE;
			n_AS_SKILL[idx][1] = eval(document.calcForm.SkillSubNum2.value);
			n_AS_SKILL[idx][2] = 1000;
			n_AS_SKILL[idx][3] = -4;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// 通常攻撃時の、スペルフィストにおける精霊効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 || n_A_ActiveSkill == 660){

		if(SkillSearch(813) == 1 && (SkillSearch(812) == 3 || SkillSearch(812) == 6 || SkillSearch(812) == 9 || SkillSearch(812) == 12)){
			if(SkillSearch(812) == 3) n_AS_SKILL[idx][0] = 51;
			if(SkillSearch(812) == 6) n_AS_SKILL[idx][0] = 54;
			if(SkillSearch(812) == 9) n_AS_SKILL[idx][0] = 56;
			if(SkillSearch(812) == 12) n_AS_SKILL[idx][0] = 132;
			n_AS_SKILL[idx][1] = ROUNDDOWN(n_A_JobLV / 10);
			if(n_A_JobLV <10) n_AS_SKILL[idx][1] = 1;
			n_AS_SKILL[idx][2] = ROUNDDOWN(n_A_JobLV * 10 / 2);
			if(n_Enekyori==1) n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] / 2;
			if(wAS_3dan > 0) n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] * (100 - wAS_3dan) / 100;
			n_AS_SKILL[idx][3] = 0;
			idx++;
			if(n_AS_SKILL[idx-1][0] == 51 || n_AS_SKILL[idx-1][0] == 54 || n_AS_SKILL[idx-1][0] == 56){
				if(SkillSearch(755)){
					n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
					n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
					n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * (30 + 10 * SkillSearch(755)) * 10 / 100;
					n_AS_SKILL[idx][3] = 0;
					idx++;
				}else if(TimeItemNumSearch(76)){
					n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
					n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
					n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * 40 * 10 / 100;
					n_AS_SKILL[idx][3] = 0;
					idx++;
				}
			}
		}


		// 通常オートスペル
		for (var asidx = 0; asidx < AUTO_SPELL_SETTING_COUNT; asidx++){

			// 指定欄のオートスペルＩＤを取得
			var asId = n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_ID + asidx];

			// 初期処理時は処理しない
			if (asId == undefined) {
				break;
			}

			// 未指定の場合は処理しない
			if (asId == 0) {
				continue;
			}

			// 発動するスキルのＩＤを取得
			n_AS_SKILL[idx][0] = AutoSpellSkill[asId][2];

			// 発動するレベルを取得
			n_AS_SKILL[idx][1] = AutoSpellSkill[asId][3];

			// レベルが指定されている場合は上書き
			if (n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_LV + asidx] != 0) {
				n_AS_SKILL[idx][1] = n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_LV + asidx];
			}

			// 発動率を取得
			n_AS_SKILL[idx][2] = AUTO_SPELL_PROB_ARRAY[n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_PROB + asidx]];

			// 遠距離攻撃の場合は、発動率半減
			if (n_Enekyori == 1) {
				n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] / 2;
			}

			// 三段掌発動時は、ＡＳは発動しないので、発動率を補正
			if(wAS_3dan > 0) {
				n_AS_SKILL[idx][2] = n_AS_SKILL[idx][2] * (100 - wAS_3dan) / 100;
			}

			// オートスペルフラグは、一般オートスペル
			n_AS_SKILL[idx][3] = 0;

			// 設定インデックスをインクリメント
			idx++;


			// ダブルキャスティングの効果
			if(n_AS_SKILL[idx - 1][0] == 51 || n_AS_SKILL[idx - 1][0] == 54 || n_AS_SKILL[idx - 1][0] == 56){
				if(SkillSearch(755)){
					n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
					n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
					n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * (30 + 10 * SkillSearch(755)) * 10 / 100;
					n_AS_SKILL[idx][3] = 0;
					idx++;
				}else if(TimeItemNumSearch(76)){
					n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
					n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
					n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * 40 * 10 / 100;
					n_AS_SKILL[idx][3] = 0;
					idx++;
				}
			}
		}
	}


	//----------------------------------------------------------------
	// ボルト使用時の、ダブルキャスティング効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 51 || n_A_ActiveSkill == 54 || n_A_ActiveSkill == 56){
		if(SkillSearch(755)){
			n_AS_SKILL[idx][0] = n_A_ActiveSkill;
			n_AS_SKILL[idx][1] = n_A_ActiveSkillLV;
			n_AS_SKILL[idx][2] = (30 + 10 * SkillSearch(755)) * 10;
			n_AS_SKILL[idx][3] = 0;
			idx++;
		}else if(TimeItemNumSearch(76)){
			n_AS_SKILL[idx][0] = n_A_ActiveSkill;
			n_AS_SKILL[idx][1] = n_A_ActiveSkillLV;
			n_AS_SKILL[idx][2] = 40 * 10;
			n_AS_SKILL[idx][3] = 0;
			idx++;
		}
	}


	//----------------------------------------------------------------
	// スペルフィスト時の、オートスペル効果
	//----------------------------------------------------------------
	if(n_A_ActiveSkill == 0 || n_A_ActiveSkill == 660){
		if(SkillSearch(743) && SkillSearch(229)){
			var w = SkillSearch(743);
			if(w == 1) n_AS_SKILL[idx][0] = 51;
			if(w == 2) n_AS_SKILL[idx][0] = 54;
			if(w == 3) n_AS_SKILL[idx][0] = 56;
			if(w == 4) n_AS_SKILL[idx][0] = 47;
			n_AS_SKILL[idx][1] = 3;
			if(SkillSearch(749)) n_AS_SKILL[idx][1] = SkillSearch(749);
			n_AS_SKILL[idx][2] = (5 + 2 * SkillSearch(229)) * 10;
			n_AS_SKILL[idx][3] = -1;
			idx++;
			if(1 <= w && w <= 3){
				if(SkillSearch(755)){
					n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
					n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
					n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * (30 + 10 * SkillSearch(755)) * 10 / 100;
					n_AS_SKILL[idx][3] = -1;
					idx++;
				}else if(TimeItemNumSearch(76)){
					n_AS_SKILL[idx][0] = n_AS_SKILL[idx-1][0];
					n_AS_SKILL[idx][1] = n_AS_SKILL[idx-1][1];
					n_AS_SKILL[idx][2] = n_AS_SKILL[idx-1][2] / 10 * 40 * 10 / 100;
					n_AS_SKILL[idx][3] = -1;
					idx++;
				}
			}
		}
	}


	// 発動率の上限（100.0%）補正
	for (var idxsub = 0; idxsub <= idx; idxsub++) {
		if (n_AS_SKILL[idxsub][2] > 1000) {
			n_AS_SKILL[idxsub][2] = 1000;
		}
	}


	n_AS_SKILL[idx][0] = -1;
	if(n_AS_SKILL[0][0] == -1) return;
	n_AS_MODE = 1;

	//----------------------------------------------------------------
	// 表示ＨＴＭＬ組み立て（未解析）
	//----------------------------------------------------------------

	var BK_SKILL = n_A_ActiveSkill;
	var BK_SKILL_LV = n_A_ActiveSkillLV;
	var BK_ZOKUSEI = n_A_Weapon_zokusei;
	var BK_ENKYORI = n_Enekyori;
	var BK_DMG0 = n_A_DMG[0];
	var BK_DMG1 = n_A_DMG[1];
	var BK_DMG2 = n_A_DMG[2];
	var BK_HIT = w_HIT_HYOUJI;
	var BK_DELAY = new Array();
	for(var i=0;i<=7;i++) BK_DELAY[i] = n_Delay[i];
	if(!(BK_SKILL == 391 && n_AS_SKILL[1][0] == -1)){
		if(!(799 <= BK_SKILL && BK_SKILL <= 809)){
			str_bSUBname += "<Font size=2><B>オートスペル系</B><BR></Font>";
			str_bSUB += "<Font size=2>与ダメージ(発動率)<BR></Font>";
		}else{
			str_bSUBname += "<Font size=2><B>コンボ詳細</B><BR></Font>";
			str_bSUB += "<Font size=2>与ダメージ<BR></Font>";
		}
	}
	for(var i=0;n_AS_SKILL[i][0] != -1;i++){
		n_A_ActiveSkill = n_AS_SKILL[i][0];
		n_A_ActiveSkillLV = n_AS_SKILL[i][1];
		SET_ZOKUSEI();
		n_Enekyori = 0;
		w_HIT = n_AS_HIT;
		w_HIT = Math.floor(w_HIT * (100 + HIT_HOSEI()) / 100);
		if(w_HIT > 100){
			w_HIT = 100;
		}else if(w_HIT <5){
			w_HIT = 5;
		}
		var wSYUUREN = TYPE_SYUUREN();
		var wBaiA = GetSpiderWebDamageRatio();
		var wBaiB = GetElementFieldDamageRatio();
		for(var j=0;j<=2;j++){
			n_A_DMG[j] = BK_n_A_DMG2[j];
			n_A_DMG[j] = ApplyPhysicalSpecializeMonster(n_A_DMG[j]);
			if(wBaiA != 0) n_A_DMG[j] = ROUNDDOWN(n_A_DMG[j] * (100 + wBaiA) / 100);
			n_A_DMG[j] = ApplyElementRatio(n_A_DMG[j],n_A_Weapon_zokusei);
			if(wBaiB != 0) n_A_DMG[j] = ROUNDDOWN(n_A_DMG[j] * (100 + wBaiB) / 100);
			n_A_DMG[j] = ApplyRegistElement(n_A_DMG[j]);
			n_A_DMG[j] = n_A_StatusATK + n_A_DMG[j] + wSYUUREN;
		}
		var wDMG;
		wDMG = BattleCalc999();
		if(n_AS_SKILL[i][3] >= 0){
			if(n_AS_SKILL[i][2] != 0){
				if(n_AS_SKILL[i][3] == 11){
					if(EquipNumSearch(2513)) str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv"+ n_AS_SKILL[i][1] +"(ガラパゴ)<BR>";
					else str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv"+ n_AS_SKILL[i][1] +"(呼子)<BR>";
				}
				else str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv"+ n_AS_SKILL[i][1] +"<BR>";
				if(n_AS_SKILL[i][3] == 0) str_bSUB += wDMG[0] +"～"+ wDMG[2] +"("+ (Math.floor(n_AS_SKILL[i][2]) / 10) +"％)<BR>";
				else if(n_AS_SKILL[i][3] == 10 || n_AS_SKILL[i][3] == 11) str_bSUB += wDMG[0] +" ("+ wDMG[0] / n_AS_SKILL[i][1] +"×"+ n_AS_SKILL[i][1] +")("+ (Math.floor(n_AS_SKILL[i][2]) / 10) +"％)<BR>";
				n_AS_SKILL[i][2] = n_AS_SKILL[i][2] / 10;
				if(n_Enekyori==2){
					if(n_AS_SKILL[i][2] >= 100) n_AS_DMG[i][0] = wDMG[0];
					else n_AS_DMG[i][0] = 0;
					n_AS_DMG[i][1] = wDMG[1] * BK_HIT / 100 * n_AS_SKILL[i][2] / 100;
					n_AS_DMG_OverHP[i][1] = n_B[3] * BK_HIT / 100 * n_AS_SKILL[i][2] / 100;
					n_AS_DMG[i][2] = wDMG[2];
				}
				if(n_Enekyori==0 || n_Enekyori==1){
					if(n_AS_SKILL[i][2] >= 100 && BK_HIT >= 100 && w_HIT >= 100) n_AS_DMG[i][0] = wDMG[0];
					else n_AS_DMG[i][0] = 0;
					n_AS_DMG[i][1] = wDMG[1] * BK_HIT / 100 * w_HIT / 100 * n_AS_SKILL[i][2] / 100;
					n_AS_DMG_OverHP[i][1] = n_B[3] * BK_HIT / 100 * w_HIT / 100 * n_AS_SKILL[i][2] / 100;
					n_AS_DMG[i][2] = wDMG[2];
					if(n_AS_SKILL[i][2] <= 0) n_AS_DMG[i][2] = 0;
				}
			}else{
				str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv"+ n_AS_SKILL[i][1] +"<BR>";
				str_bSUB += "発動率不明で計算から除外<BR>";
				n_AS_DMG[i][0] = 0;
				n_AS_DMG[i][1] = 0;
				n_AS_DMG[i][2] = 0;
			}
		}else if(n_AS_SKILL[i][3] == -1){
			if(SkillSearch(749) == 0){
				str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv1-3<BR>";
				str_bSUB += (wDMG[0] / 3) +"～"+ wDMG[2] +"("+ (Math.floor(n_AS_SKILL[i][2]) / 10) +"％)<BR>";
				n_AS_SKILL[i][2] = n_AS_SKILL[i][2] / 10;
				n_AS_DMG[i][0] = 0;
				n_AS_DMG[i][1] = (wDMG[1] / 3 * 50 + wDMG[1] * 2 / 3 * 35 + wDMG[1] * 15) / 100 * n_AS_SKILL[i][2] / 100;
				n_AS_DMG_OverHP[i][1] = (n_B[3] / 3 * 50 + n_B[3] * 2 / 3 * 35 + n_B[3] * 15) / 100 * n_AS_SKILL[i][2] / 100;
				n_AS_DMG[i][2] = wDMG[2];
			}else{
				str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv"+ SkillSearch(749) +"<BR>";
				str_bSUB += wDMG[0] +"～"+ wDMG[2] +"("+ (Math.floor(n_AS_SKILL[i][2]) / 10) +"％)<BR>";
				n_AS_SKILL[i][2] = n_AS_SKILL[i][2] / 10;
				n_AS_DMG[i][0] = 0;
				n_AS_DMG[i][1] = wDMG[1] * n_AS_SKILL[i][2] / 100;
				n_AS_DMG_OverHP[i][1] = n_B[3] * n_AS_SKILL[i][2] / 100;
				n_AS_DMG[i][2] = wDMG[2];
			}
		}else if(n_AS_SKILL[i][3] == -2){
			InnStr[0] += "＋";
			InnStr[1] += "＋";
			InnStr[2] += "＋";
			if(n_AS_SKILL[i][2] >= 100 && w_HIT >= 100) n_AS_DMG[i][0] = wDMG[0];
			else n_AS_DMG[i][0] = 0;
			n_AS_DMG[i][1] = wDMG[1] * w_HIT / 100 * n_AS_SKILL[i][2] / 100;
			n_AS_DMG_OverHP[i][1] = n_B[3] * w_HIT / 100 * n_AS_SKILL[i][2] / 100;
			n_AS_DMG[i][2] = wDMG[2];
			if(n_AS_SKILL[i][2] <= 0) n_AS_DMG[i][2] = 0;
		}else if(n_AS_SKILL[i][3] == -3){
			var wDMG2;
			var wDMG3;
			n_A_ActiveSkillLV = 3;
			wDMG2 = BattleCalc999();
			n_A_ActiveSkillLV = 5;
			wDMG3 = BattleCalc999();
			str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv1～5<BR>";
			str_bSUB += wDMG[0] +"～"+ wDMG3[2] +"("+ n_AS_SKILL[i][2] +"％)<BR>";
			if(n_AS_SKILL[i][2] >= 100) n_AS_DMG[i][0] = wDMG[0];
			else n_AS_DMG[i][0] = 0;
			n_AS_DMG[i][1] = wDMG2[1] * n_AS_SKILL[i][2] / 100;
			n_AS_DMG_OverHP[i][1] = n_B[3] * n_AS_SKILL[i][2] / 100;
			n_AS_DMG[i][2] = wDMG3[2];
		}else if(n_AS_SKILL[i][3] == -4){
			str_bSUBname += SkillObjNew[n_AS_SKILL[i][0]][SKILL_DATA_INDEX_NAME] +"Lv"+ n_AS_SKILL[i][1] +"<BR>";
			str_bSUB += wDMG[0] +"～"+ wDMG[2] +"<BR>";
			n_AS_SKILL[i][2] = n_AS_SKILL[i][2] / 10;
			if(w_HIT >= 100) n_AS_DMG[i][0] = wDMG[0];
			else n_AS_DMG[i][0] = 0;
			n_AS_DMG[i][1] = wDMG[1] * w_HIT / 100 * n_AS_SKILL[i][2] / 100;
			n_AS_DMG_OverHP[i][1] = n_B[3] * w_HIT / 100 * n_AS_SKILL[i][2] / 100;
			n_AS_DMG[i][2] = wDMG[2];
		}
	}
	w_HIT_HYOUJI = BK_HIT;
	n_A_DMG[0] = BK_DMG0;
	n_A_DMG[1] = BK_DMG1;
	n_A_DMG[2] = BK_DMG2;
	n_A_ActiveSkill = BK_SKILL;
	n_A_ActiveSkillLV = BK_SKILL_LV;
	n_A_Weapon_zokusei = BK_ZOKUSEI;
	n_Enekyori = BK_ENKYORI;
	for(var i=0;i<=7;i++) n_Delay[i] = BK_DELAY[i];
	n_AS_MODE = 0;
	if(n_A_ActiveSkill == 0 && n_AS_SKILL[0][0] != 0 && (SkillSearch(187) || w998D)){
		str_bSUBname += "<B><Font size=2>通常</Font></B><BR>";
		str_bSUB += "<BR>";
	}
 }





function AS_PLUS(){

	w_DMG_AS_OverHP = w_DMG[1];

	if(n_AS_check_3dan == 0){
		for(var j = 0; j < n_AS_DMG.length; j++){
			for(var i = 0; i <= 2; i++){
				if(i == 1) {
					w_DMG_AS_OverHP += n_AS_DMG_OverHP[j][i];
				}
				w_DMG[i] += n_AS_DMG[j][i];
			}
		}
	}

	else{
		for(var j = 0; j < n_AS_DMG.length; j++){
			for(var i = 0; i <= 1; i++){
				w_DMG[i] += n_AS_DMG[j][i];
			}
		}
	}
 }












































































//================================================================================================
//
// 定数定義
//
//================================================================================================
OBJID_OFFSET_AS_SKILL_ID = 100;			// オブジェクトＩＤのオフセット（オートスペル　スキルＩＤ）
OBJID_OFFSET_AS_SKILL_LV = 200;			// オブジェクトＩＤのオフセット（オートスペル　スキルレベル）
OBJID_OFFSET_AS_SKILL_PROB = 300;		// オブジェクトＩＤのオフセット（オートスペル　スキル発動率）





//================================================================================================
//
// グローバル変数定義
//
//================================================================================================





//================================================================================================
//
// 処理
//
//================================================================================================

/************************************************************************************************
 *
 * オートスペル設定欄の展開（再構築）.
 *
 ************************************************************************************************/
function OnClickExtractSettingAutoSpell(){

	var objRoot = null;
	var objTable = null;
	var objTbody = null;
	var objTr = null;
	var objTd = null;
	var objInput = null;
	var objSpan = null;
	var objText = null;



	// 再構築前の、チェックボックスの指定状況を保持
	var htmlSwitchAS = 0;
	objInput = document.getElementById("OBJID_EXTRACT_SETTING_AUTO_SPELL");
	if (objInput != undefined) {
		htmlSwitchAS = objInput.checked;
	}



	//================================================================
	// オートスペル設定欄を再構築する
	//================================================================

	// ルート要素配下を全削除
	objRoot = document.getElementById("SP_SIEN03");
	HtmlRemoveAllChild(objRoot);

	// 整形用テーブル生成
	objTable = document.createElement("table");
	objRoot.appendChild(objTable);
	objTable.setAttribute("border", "1");

	objTbody = document.createElement("tbody");
	objTable.appendChild(objTbody);


	//----------------------------------------------------------------
	// ヘッダ行
	//----------------------------------------------------------------
	objTr = document.createElement("tr");
	objTbody.appendChild(objTr);

	objTd = document.createElement("td");
	objTr.appendChild(objTd);
	objTd.setAttribute("class", "title");
	objTd.setAttribute("id", "OBJID_TD_AUTO_SPELL_SETTING");

	// 設定欄展開用チェックボックス
	objInput = document.createElement("input");
	objTd.appendChild(objInput);
	objInput.setAttribute("type", "checkbox");
	objInput.setAttribute("id", "OBJID_EXTRACT_SETTING_AUTO_SPELL");
	objInput.setAttribute("onClick", "OnClickExtractSettingAutoSpell()");

	// ヘッダ行表示テキスト
	objText = document.createTextNode("オートスペル設定 (テスト中)");
	objTd.appendChild(objText);

	// 使用中表示マーカー
	objSpan = document.createElement("span");
	objTd.appendChild(objSpan);
	objSpan.setAttribute("id", "OBJID_USED_MARKER_AUTO_SPELL");



	//----------------------------------------------------------------
	// 欄が展開表示の場合は、ＨＴＭＬを構築
	//----------------------------------------------------------------
	if (htmlSwitchAS) {
		BuildUpSettingHtmlAutoSpell(objTbody);
	}


	//----------------------------------------------------------------
	// 部品を再構築したので、再設定が必要
	//----------------------------------------------------------------
	objInput = document.getElementById("OBJID_EXTRACT_SETTING_AUTO_SPELL");
	if (objInput != undefined) {
		objInput.checked = htmlSwitchAS;
	}

	// オートスペル設定変更イベントハンドラを実行（再計算はしない）
	OnChangeSettingAutoSpell(false);
}



/************************************************************************************************
 *
 * オートスペル設定欄の展開構築.
 *
 *-----------------------------------------------------------------------------------------------
 * @param objTbody 構築対象のＴＢＯＤＹ要素
 ************************************************************************************************/
function BuildUpSettingHtmlAutoSpell(objTbody) {
	var str = "";


	var objTr = null;
	var objTd = null;
	var objInput = null;
	var objSpan = null;
	var objText = null;
	var objSelect = null;
	var objOption = null;

	var optionText = "";
	var optionValue = 0;


	//----------------------------------------------------------------
	// 簡易設定ボタン
	//----------------------------------------------------------------

	objTr = document.createElement("tr");
	objTbody.appendChild(objTr);

	objTd = document.createElement("td");
	objTr.appendChild(objTd);

	objInput = document.createElement("input");
	objTd.appendChild(objInput);
	objInput.setAttribute("type", "button");
	objInput.setAttribute("value", "簡易設定");
	objInput.setAttribute("onClick", "OnClickEasySetUpAutoSpell()");



	//----------------------------------------------------------------
	// 設定行
	//----------------------------------------------------------------

	for (var idx = 0; idx < AUTO_SPELL_SETTING_COUNT; idx++) {
		objTr = document.createElement("tr");
		objTbody.appendChild(objTr);

		objTd = document.createElement("td");
		objTr.appendChild(objTd);


		//----------------------------------------------------------------
		// スキル選択セレクトボックス
		//----------------------------------------------------------------
		objSelect = document.createElement("select");
		objTd.appendChild(objSelect);
		objSelect.setAttribute("id", "OBJID_AS_SKILL_ID_" + (OBJID_OFFSET_AS_SKILL_ID + idx));
		objSelect.setAttribute("onChange", "OnChangeSettingAutoSpell(true)");

		//----------------------------------------------------------------
		// オートスペルをソートする
		//----------------------------------------------------------------
		// 名称ソートするために、名称データを引っ張ってくる
		for (var asidx = 0; asidx < AutoSpellSkill.length; asidx++) {
			var objAS = AutoSpellSkill[asidx];

			// スキル名を取得する
			objAS[AS_SKILL_DATA_INDEX_SORT_NAME] = SkillObjNew[objAS[AS_SKILL_DATA_INDEX_SKILL_ID]][SKILL_DATA_INDEX_NAME];

			// オートスペル発動レベルを、名称の末尾に追加する
			objAS[AS_SKILL_DATA_INDEX_SORT_NAME] += objAS[AS_SKILL_DATA_INDEX_MAXLV];
		}

		// 名称ソート実行
		AutoSpellSkill.sort(
			function(a, b) {
				if (a[AS_SKILL_DATA_INDEX_SORT_NAME] < b[AS_SKILL_DATA_INDEX_SORT_NAME]) return -1;
				if (a[AS_SKILL_DATA_INDEX_SORT_NAME] > b[AS_SKILL_DATA_INDEX_SORT_NAME]) return 1;
				return 0;
			}
		);

		//----------------------------------------------------------------
		// データの追加
		//----------------------------------------------------------------
		// 先頭の選択肢として指定なしを追加
		optionText = "(なし)";
		optionValue = 0;

		objOption = HtmlCreateElementOption(optionValue, optionText);
		objSelect.appendChild(objOption);

		// 全てのオートスペルデータを走査して、スキルを追加する
		for (var asidx = 0; asidx < AutoSpellSkill.length; asidx++) {

			// 対象外スキルの場合は処理しない
			if(AutoSpellSkill[asidx][AS_SKILL_DATA_INDEX_ATTACKABLE_FLAG] != 1){
				continue;
			}

			var skillId = AutoSpellSkill[asidx][AS_SKILL_DATA_INDEX_SKILL_ID];
			var skillLv = AutoSpellSkill[asidx][AS_SKILL_DATA_INDEX_MAXLV];
			var skillName = SkillObjNew[skillId][SKILL_DATA_INDEX_NAME];

			optionText = "[Lv" + skillLv + "] "+ skillName;
			optionValue = AutoSpellSkill[asidx][AS_SKILL_DATA_INDEX_ID];

			switch (skillId) {
			case SKILL_ID_TURN_UNDEAD:
				optionText += "(式不明)";
				break;
			case SKILL_ID_STORM_GUST:
				optionText += "(10hits)";
				break;
			}

			objOption = HtmlCreateElementOption(optionValue, optionText);
			objSelect.appendChild(objOption);
		}

		// 初期値を設定
		objSelect.value = n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_ID + idx];


		//----------------------------------------------------------------
		// オートスペルのソートを戻す
		//----------------------------------------------------------------
		// IDソート実行
		AutoSpellSkill.sort(
			function(a, b) {
				if (a[AS_SKILL_DATA_INDEX_ID] < b[AS_SKILL_DATA_INDEX_ID]) return -1;
				if (a[AS_SKILL_DATA_INDEX_ID] > b[AS_SKILL_DATA_INDEX_ID]) return 1;
				return 0;
			}
		);


		//----------------------------------------------------------------
		// レベル選択セレクトボックス
		//----------------------------------------------------------------
		objSelect = document.createElement("select");
		objTd.appendChild(objSelect);
		objSelect.setAttribute("id", "OBJID_AS_SKILL_LV_" + (OBJID_OFFSET_AS_SKILL_LV + idx));
		objSelect.setAttribute("onChange", "OnChangeSettingAutoSpell(true)");

		// Lv-, 1, 2, ... , 10 を設定
		for (var lvidx = 0; lvidx <= 10; lvidx++) {
			optionText = "Lv" + (lvidx == 0 ? "-" : lvidx);
			optionValue = lvidx;

			objOption = HtmlCreateElementOption(optionValue, optionText);
			objSelect.appendChild(objOption);
		}

		// 初期値を設定
		objSelect.value = n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_LV + idx];


		//----------------------------------------------------------------
		// 発動率選択セレクトボックス
		//----------------------------------------------------------------
		objSelect = document.createElement("select");
		objTd.appendChild(objSelect);
		objSelect.setAttribute("id", "OBJID_AS_SKILL_PROB_" + (OBJID_OFFSET_AS_SKILL_PROB + idx));
		objSelect.setAttribute("onChange", "OnChangeSettingAutoSpell(true)");

		for (var probidx = 0; probidx < AUTO_SPELL_PROB_ARRAY.length; probidx++) {
			optionText = (AUTO_SPELL_PROB_ARRAY[probidx] / 10) + "%";
			optionValue = probidx;

			objOption = HtmlCreateElementOption(optionValue, optionText);
			objSelect.appendChild(objOption);
		}

		// 初期値を設定
		objSelect.value = n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_PROB + idx];

	}
}





/************************************************************************************************
 *
 * オートスペル設定　設定変更イベントハンドラ.
 *
 *-----------------------------------------------------------------------------------------------
 * @param bCalculate 再計算フラグ
 ************************************************************************************************/
function OnChangeSettingAutoSpell(bCalculate){

	// 再計算フラグが指定されている場合は、再計算を行う
	if (bCalculate) calc();


	// オートスペル設定が指定されているかをチェック
	var bSet = false;
	for (var idx = 0 ; idx < AUTO_SPELL_SETTING_COUNT; idx++) {
		bSet = true;
		if (n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_ID + idx] != 0) break;
		if (n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_LV + idx] != 0) break;
		if (n_A_PassSkill5[OBJID_OFFSET_AS_SKILL_PROB + idx] != 0) break;
		bSet = false;
	}


	// 設定状況に応じて、ヘッダの内容を切り替え
	if (bSet) {
		document.getElementById('OBJID_TD_AUTO_SPELL_SETTING').style.backgroundColor = "#FF7777";
		myInnerHtml("OBJID_USED_MARKER_AUTO_SPELL","　<B>使用中</B>",0);
	}
	else{
		document.getElementById('OBJID_TD_AUTO_SPELL_SETTING').style.backgroundColor = "#DDDDFF";
		myInnerHtml("OBJID_USED_MARKER_AUTO_SPELL","",0);
	}
 }





/************************************************************************************************
 *
 * オートスペルの簡易設定を行う.
 *
 ************************************************************************************************/
function OnClickEasySetUpAutoSpell(){


	var objSelect = null;

	var asidx = 0;
	var asIdArray = new Array();


	//----------------------------------------------------------------
	// 初めに、デフォルト（なし）に設定しておく
	//----------------------------------------------------------------
	for (var idx = 0 ; idx < AUTO_SPELL_SETTING_COUNT; idx++) {
		objSelect = document.getElementById("OBJID_AS_SKILL_ID_" + (OBJID_OFFSET_AS_SKILL_ID + idx));
		objSelect.value = 0;
		objSelect = document.getElementById("OBJID_AS_SKILL_LV_" + (OBJID_OFFSET_AS_SKILL_LV + idx));
		objSelect.value = 0;
		objSelect = document.getElementById("OBJID_AS_SKILL_PROB_" + (OBJID_OFFSET_AS_SKILL_PROB + idx));
		objSelect.value = 0;
	}



	//----------------------------------------------------------------
	// 装備のオートスペルを設定する
	//----------------------------------------------------------------
	for(var eqpidx = 0; eqpidx < n_A_Equip.length; eqpidx++){

		// 該当装備箇所のアイテムデータを取得
		var itemData = ItemObjNew[n_A_Equip[eqpidx]];

		for(var j2 = 0; ; j2 += 2) {

			// アイテムのＳＰ定義ＩＤを取得
			var itemSpId = itemData[ITEM_DATA_INDEX_SPBEGIN + j2];

			// ＳＰ定義終了ならば処理を抜ける
			if (itemSpId == ITEM_SP_END) {
				break;
			}

			// ＳＰ定義がオートスペル定義で無い場合、処理しない
			if ((itemSpId != ITEM_SP_AUTO_SPELL) && (itemSpId != ITEM_SP_AUTO_SPELL_LEVEL_UNSPECIFIED)) {
				continue;
			}

			// アイテムのＳＰ定義値を取得（オートスペルＩＤが設定されている）
			var asId = itemData[ITEM_DATA_INDEX_SPBEGIN + j2 + 1];

			// 当該オートスペルが設定対象外の場合、処理しない
			if (AutoSpellSkill[asId][1] != 1) {
				continue;
			}

			// 当該オートスペルが物理攻撃時オートスペルでない場合、処理しない
			switch (AutoSpellSkill[asId][5]) {
			case AS_TRIGGER_PHYSICAL_ATTACK:
			case AS_TRIGGER_SHORTRANGE_ATTACK:
			case AS_TRIGGER_LONGRANGE_ATTACK:
			case AS_TRIGGER_ANY_ATTACK:
				break;
			default:
				continue;
			}

			asIdArray[asidx] = asId;
			asidx++;
		}
	}



	//----------------------------------------------------------------
	// カードのオートスペルを設定する
	//----------------------------------------------------------------
	for(var eqpidx = 0; eqpidx < n_A_card.length; eqpidx++){

		// 該当装備箇所のアイテムデータを取得
		var cardData = CardObjNew[n_A_card[eqpidx]];

		for(var j2 = 0; ; j2 += 2) {

			// アイテムのＳＰ定義ＩＤを取得
			var cardSpId = cardData[CARD_DATA_INDEX_SPBEGIN + j2];

			// ＳＰ定義終了ならば処理を抜ける
			if (cardSpId == ITEM_SP_END) {
				break;
			}

			// ＳＰ定義がオートスペル定義で無い場合、処理しない
			if ((cardSpId != ITEM_SP_AUTO_SPELL) && (cardSpId != ITEM_SP_AUTO_SPELL_LEVEL_UNSPECIFIED)) {
				continue;
			}

			// アイテムのＳＰ定義値を取得（オートスペルＩＤが設定されている）
			var asId = cardData[CARD_DATA_INDEX_SPBEGIN + j2 + 1];

			// 当該オートスペルが設定対象外の場合、処理しない
			if (AutoSpellSkill[asId][1] != 1) {
				continue;
			}

			// 当該オートスペルが物理攻撃時オートスペルでない場合、処理しない
			switch (AutoSpellSkill[asId][5]) {
			case AS_TRIGGER_PHYSICAL_ATTACK:
			case AS_TRIGGER_SHORTRANGE_ATTACK:
			case AS_TRIGGER_LONGRANGE_ATTACK:
			case AS_TRIGGER_ANY_ATTACK:
				break;
			default:
				continue;
			}

			asIdArray[asidx] = asId;
			asidx++;
		}
	}



	//================================================================
	//
	// 特殊条件で追加されるオートスペル
	//
	//================================================================

	//----------------------------------------------------------------
	// 「マジカルブレード」の、精錬値による効果
	//----------------------------------------------------------------
	var refined = -1;
	var itemCountRight = EquipNumSearch(ITEM_ID_MAGICAL_BLADE, EQUIP_REGION_ID_ARMS_RIGHT);
	var itemCountLeft = EquipNumSearch(ITEM_ID_MAGICAL_BLADE, EQUIP_REGION_ID_ARMS_LEFT);
	// 装備状況によって、参照する精錬値を切り替える
	if ((itemCountRight > 0) && (itemCountLeft > 0)) {
		if (n_A_Weapon_ATKplus >= n_A_Weapon2_ATKplus) {
			refined = n_A_Weapon_ATKplus;
		}
		else {
			refined = n_A_Weapon2_ATKplus;
		}
	}
	else if (itemCountRight > 0) {
		refined = n_A_Weapon_ATKplus;
	}
	else if (itemCountLeft > 0) {
		refined = n_A_Weapon2_ATKplus;
	}
	// 精錬値によって、発動するオートスペルを追加
	if (refined >= 0) {
		asIdArray[asidx] = 129;
		asidx++;
	}
	if (refined >= 2) {
		asIdArray[asidx] = 130;
		asidx++;
	}
	if (refined >= 4) {
		asIdArray[asidx] = 131;
		asidx++;
	}
	if (refined >= 6) {
		asIdArray[asidx] = 132;
		asidx++;
	}
	if (refined >= 8) {
		asIdArray[asidx] = 133;
		asidx++;
	}


	//----------------------------------------------------------------
	// 「死神の名簿」の、職業による効果
	//----------------------------------------------------------------
	var itemCountRight = EquipNumSearch(ITEM_ID_SHINIGAMINO_MEIBO, EQUIP_REGION_ID_ARMS_RIGHT);
	var itemCountLeft = EquipNumSearch(ITEM_ID_SHINIGAMINO_MEIBO, EQUIP_REGION_ID_ARMS_LEFT);
	if ((itemCountRight > 0) || (itemCountLeft > 0)) {
		if (GetHigherJobSeriesID(n_A_JOB) == JOB_SERIES_ID_SAGE) {
			asIdArray[asidx] = 138;
			asidx++;
		}
	}


	//----------------------------------------------------------------
	// 「グロリアスクロー」の、精錬による効果
	//----------------------------------------------------------------
	var itemCountRight = EquipNumSearch(ITEM_ID_GLORIOUS_CLAW, EQUIP_REGION_ID_ARMS_RIGHT);
	var itemCountLeft = EquipNumSearch(ITEM_ID_GLORIOUS_CLAW, EQUIP_REGION_ID_ARMS_LEFT);
	if (((itemCountRight > 0) && (n_A_Weapon_ATKplus >= 9))
		|| ((itemCountLeft > 0) && (n_A_Weapon2_ATKplus >= 9))) {
		asIdArray[asidx] = 108;
		asidx++;
	}


	//----------------------------------------------------------------
	// 「女王フェイスワームの足」の、効果
	//----------------------------------------------------------------
	var itemCountRight = EquipNumSearch(ITEM_ID_ZYOO_FACEWORMNO_ASHI, EQUIP_REGION_ID_ARMS_RIGHT);
	var itemCountLeft = EquipNumSearch(ITEM_ID_ZYOO_FACEWORMNO_ASHI, EQUIP_REGION_ID_ARMS_LEFT);
	if ((itemCountRight > 0) || (itemCountLeft > 0)) {
		asIdArray[asidx] = 154;
		asidx++;
	}


	//----------------------------------------------------------------
	// 「慰める者カード」の、職業による効果
	//----------------------------------------------------------------
	if ((cardCount = CardNumSearch(CARD_ID_NAGUSAMERUMONO)) > 0) {
		if (GetHigherJobSeriesID(n_A_JOB) == JOB_SERIES_ID_PRIEST) {
			asIdArray[asidx] = 95;
			asidx++;
		}
	}


	//----------------------------------------------------------------
	// 「グリフォンカード」の、職業による効果
	//----------------------------------------------------------------
	if ((cardCount = CardNumSearch(CARD_ID_GRIFFIN)) > 0) {
		if (GetLowerJobSeriesID(n_A_JOB) == JOB_SERIES_ID_SWORDMAN) {
			asIdArray[asidx] = 96;
			asidx++;
		}
	}




	//================================================================
	//
	// 最終的なオートスペルで設定を構築
	//
	//================================================================

	for (var idx = 0 ; idx < AUTO_SPELL_SETTING_COUNT; idx++) {
		var asId = asIdArray[idx];

		// 全てのデータを設定し終わったら、処理終了
		if (asId == undefined) {
			break;
		}

		// 発動するスキル
		objSelect = document.getElementById("OBJID_AS_SKILL_ID_" + (OBJID_OFFSET_AS_SKILL_ID + idx));
		objSelect.value = AutoSpellSkill[asId][0];

		// 発動するレベル
		objSelect = document.getElementById("OBJID_AS_SKILL_LV_" + (OBJID_OFFSET_AS_SKILL_LV + idx));
		objSelect.value = AutoSpellSkill[asId][3];

		// マジカルブレードの特殊処理（邪魔）
		if(129 <= asIdArray[idx] && asIdArray[idx] <= 133) {
			if((n_A_Equip[EQUIP_REGION_ID_ARMS_RIGHT] == 1658 && n_A_Weapon_ATKplus >= 10)
				|| (n_A_Equip[EQUIP_REGION_ID_ARMS_LEFT] == 1658 && n_A_Weapon2_ATKplus >= 10)) {
					objSelect.value = 5;
			}
		}

		// 発動率
		objSelect = document.getElementById("OBJID_AS_SKILL_PROB_" + (OBJID_OFFSET_AS_SKILL_PROB + idx));
		objSelect.value = AutoSpellSkill[asId][4];

		// 発動率が規定の発動率リストに存在するかをチェック
		if(AutoSpellSkill[asId][4] != 0){
			var probidx = 0;
			for (probidx = 0; probidx < AUTO_SPELL_PROB_ARRAY.length; probidx++) {
				if (AUTO_SPELL_PROB_ARRAY[probidx] == (AutoSpellSkill[asId][4] * 10)) {
					objSelect.value = probidx;
					break;
				}
			}
			// 存在しない場合はエラーにしておく
			if (probidx == AUTO_SPELL_PROB_ARRAY.length) {
				objSelect.value = 0;
			}
		}
	}


	// オートスペル設定変更イベントを実行
	OnChangeSettingAutoSpell(true);
 }

