//================================================================================================
//================================================================================================
//====
//==== グローバルデータ変数定義（このファイル内部でデータ定義すること）
//====
//================================================================================================
//================================================================================================
// ジョブボーナスデータ配列
G_JOB_BONUS_DATA = Array();





//================================================================================================
//================================================================================================
//====
//==== パラメタ定義
//====
//================================================================================================
//================================================================================================

var const_identifier = 0;

PARAM_STR	= const_identifier++;
PARAM_AGI	= const_identifier++;
PARAM_VIT	= const_identifier++;
PARAM_INT	= const_identifier++;
PARAM_DEX	= const_identifier++;
PARAM_LUK	= const_identifier++;
PARAM_COUNT	= const_identifier++;



const_identifier = 0;

RACE_ID_SOLID	= const_identifier++;
RACE_ID_UNDEAD	= const_identifier++;
RACE_ID_ANIMAL	= const_identifier++;
RACE_ID_PLANT	= const_identifier++;
RACE_ID_INSECT	= const_identifier++;
RACE_ID_FISH	= const_identifier++;
RACE_ID_DEMON	= const_identifier++;
RACE_ID_HUMAN	= const_identifier++;
RACE_ID_ANGEL	= const_identifier++;
RACE_ID_DRAGON	= const_identifier++;
RACE_ID_COUNT	= const_identifier++;



const_identifier = 0;

ELM_ID_VANITY	= const_identifier++;
ELM_ID_WATER 	= const_identifier++;
ELM_ID_EARTH 	= const_identifier++;
ELM_ID_FIRE 	= const_identifier++;
ELM_ID_WIND 	= const_identifier++;
ELM_ID_POISON 	= const_identifier++;
ELM_ID_HOLY 	= const_identifier++;
ELM_ID_DARK 	= const_identifier++;
ELM_ID_PSYCO 	= const_identifier++;
ELM_ID_UNDEAD 	= const_identifier++;
ELM_ID_COUNT	= const_identifier++;



const_identifier = 0;

SIZE_ID_SMALL	= const_identifier++;
SIZE_ID_MEDIUM	= const_identifier++;
SIZE_ID_LARGE	= const_identifier++;
SIZE_ID_COUNT	= const_identifier++;



const_identifier = 0;

STATE_ID_POISON	= const_identifier++;
STATE_ID_STUN	= const_identifier++;
STATE_ID_FROZEN	= const_identifier++;
STATE_ID_CURSED	= const_identifier++;
STATE_ID_BLIND	= const_identifier++;
STATE_ID_SLEEP	= const_identifier++;
STATE_ID_SILENCE	= const_identifier++;
STATE_ID_CONFUSE	= const_identifier++;
STATE_ID_BLEEDING	= const_identifier++;
STATE_ID_STONE		= const_identifier++;
STATE_ID_BREAK_WEAPON	= const_identifier++;
STATE_ID_BREAK_HEAD		= const_identifier++;
STATE_ID_BREAK_BODY		= const_identifier++;
STATE_ID_BREAK_SHIELD	= const_identifier++;
STATE_ID_BREAK_SHOULDER	= const_identifier++;
STATE_ID_BREAK_FOOT		= const_identifier++;
STATE_ID_BREAK_ACCESSARY	= const_identifier++;
STATE_ID_COUNT				= const_identifier++;





/**
 * 種族名のテキストを取得する.
 * @param raceId 種族ID
 */
function GetRaceText(raceId) {

	switch (raceId) {
	case RACE_ID_SOLID:
		return "無形";

	case RACE_ID_UNDEAD:
		return "不死";

	case RACE_ID_ANIMAL:
		return "動物";

	case RACE_ID_PLANT:
		return "植物";

	case RACE_ID_INSECT:
		return "昆虫";

	case RACE_ID_FISH:
		return "魚類";

	case RACE_ID_DEMON:
		return "悪魔";

	case RACE_ID_HUMAN:
		return "人間";

	case RACE_ID_ANGEL:
		return "天使";

	case RACE_ID_DRAGON:
		return "竜族";
	}

	return "エラー";
}



/**
 * 属性名のテキストを取得する.
 * @param elmId 属性ID
 */
function GetElementText(elmId) {

	switch (elmId) {
	case ELM_ID_VANITY:
		return "無";

	case ELM_ID_WATER:
		return "水";

	case ELM_ID_EARTH:
		return "地";

	case ELM_ID_FIRE:
		return "火";

	case ELM_ID_WIND:
		return "風";

	case ELM_ID_POISON:
		return "毒";

	case ELM_ID_HOLY:
		return "聖";

	case ELM_ID_DARK:
		return "闇";

	case ELM_ID_PSYCO:
		return "念";

	case ELM_ID_UNDEAD:
		return "不死";
	}

	return "エラー";
}



/**
 * サイズ名のテキストを取得する.
 * @param sizeId サイズID
 */
function GetSizeText(sizeId) {

	switch (sizeId) {
	case SIZE_ID_SMALL:
		return "小型";

	case SIZE_ID_MEDIUM:
		return "中型";

	case SIZE_ID_LARGE:
		return "大型";

	}

	return "エラー";
}



/**
 * 状態異常名のテキストを取得する.
 * @param stateId 状態異常ID
 */
function GetStateText(stateId) {

	switch (stateId) {
	case STATE_ID_POISON:
		return "毒";

	case STATE_ID_STUN:
		return "スタン";

	case STATE_ID_FROZEN:
		return "凍結";

	case STATE_ID_CURSED:
		return "呪い";

	case STATE_ID_BLIND:
		return "暗黒";

	case STATE_ID_SLEEP:
		return "睡眠";

	case STATE_ID_SILENCE:
		return "沈黙";

	case STATE_ID_CONFUSE:
		return "混乱";

	case STATE_ID_BLEEDING:
		return "出血";

	case STATE_ID_STONE:
		return "石化";

	case STATE_ID_BREAK_WEAPON:
		return "武器破壊";

	case STATE_ID_BREAK_HEAD:
		return "兜破壊";

	case STATE_ID_BREAK_BODY:
		return "鎧破壊";

	case STATE_ID_BREAK_SHIELD:
		return "盾破壊";

	case STATE_ID_BREAK_SHOULDER:
		return "肩破壊";

	case STATE_ID_BREAK_FOOT:
		return "靴破壊";

	case STATE_ID_BREAK_ACCESSARY:
		return "アクセ破壊";

	}

	return "エラー";
}


//================================================================================================
//================================================================================================
//====
//==== ジョブ定義
//====
//================================================================================================
//================================================================================================

const_identifier = 0;

JOB_ID_NOVICE			= const_identifier++;

JOB_ID_SWORDMAN			= const_identifier++;
JOB_ID_THIEF			= const_identifier++;
JOB_ID_ACOLYTE			= const_identifier++;
JOB_ID_ARCHER			= const_identifier++;
JOB_ID_MAGICIAN			= const_identifier++;
JOB_ID_MARCHANT			= const_identifier++;

JOB_ID_KNIGHT			= const_identifier++;
JOB_ID_ASSASIN			= const_identifier++;
JOB_ID_PRIEST			= const_identifier++;
JOB_ID_HUNTER			= const_identifier++;
JOB_ID_WIZARD			= const_identifier++;
JOB_ID_BLACKSMITH		= const_identifier++;
JOB_ID_CRUSADER			= const_identifier++;
JOB_ID_ROGUE			= const_identifier++;
JOB_ID_MONK				= const_identifier++;
JOB_ID_BARD				= const_identifier++;
JOB_ID_DANCER			= const_identifier++;
JOB_ID_SAGE				= const_identifier++;
JOB_ID_ALCHEMIST		= const_identifier++;

JOB_ID_SUPERNOVICE		= const_identifier++;

JOB_ID_LORDKNIGHT		= const_identifier++;
JOB_ID_ASSASINCROSS		= const_identifier++;
JOB_ID_HIGHPRIEST		= const_identifier++;
JOB_ID_SNIPER			= const_identifier++;
JOB_ID_HIGHWIZARD		= const_identifier++;
JOB_ID_WHITESMITH		= const_identifier++;
JOB_ID_PALADIN			= const_identifier++;
JOB_ID_CHASER			= const_identifier++;
JOB_ID_CHAMPION			= const_identifier++;
JOB_ID_CROWN			= const_identifier++;
JOB_ID_ZYPSY			= const_identifier++;
JOB_ID_PROFESSOR		= const_identifier++;
JOB_ID_CREATOR			= const_identifier++;

JOB_ID_HI_NOVICE		= const_identifier++;

JOB_ID_HI_SWORDMAN		= const_identifier++;
JOB_ID_HI_THIEF			= const_identifier++;
JOB_ID_HI_ACOLYTE		= const_identifier++;
JOB_ID_HI_ARCHER		= const_identifier++;
JOB_ID_HI_MAGICIAN		= const_identifier++;
JOB_ID_HI_MARCHANT		= const_identifier++;

JOB_ID_TAEGWON			= const_identifier++;
JOB_ID_STARGRADIATOR	= const_identifier++;
JOB_ID_SOULLINKER		= const_identifier++;
JOB_ID_NINJA			= const_identifier++;
JOB_ID_GUNSLINGER		= const_identifier++;

JOB_ID_RUNEKNIGHT		= const_identifier++;
JOB_ID_GILOTINCROSS		= const_identifier++;
JOB_ID_ARCBISHOP		= const_identifier++;
JOB_ID_RANGER			= const_identifier++;
JOB_ID_WARLOCK			= const_identifier++;
JOB_ID_MECHANIC			= const_identifier++;
JOB_ID_ROYALGUARD		= const_identifier++;
JOB_ID_SHADOWCHASER		= const_identifier++;
JOB_ID_SHURA			= const_identifier++;
JOB_ID_MINSTREL			= const_identifier++;
JOB_ID_WANDERER			= const_identifier++;
JOB_ID_SORCERER			= const_identifier++;
JOB_ID_GENETIC			= const_identifier++;

JOB_ID_KAGERO			= const_identifier++;
JOB_ID_OBORO			= const_identifier++;

JOB_ID_SUPERNOVICE_PLUS	= const_identifier++;

JOB_ID_REBELLION		= const_identifier++;

JOB_ID_COUNT = const_identifier;




/**
 * ジョブ名を取得する.
 * @param jobId ジョブＩＤ
 */
function GetJobName(jobId) {

	switch (jobId) {
	case JOB_ID_NOVICE:
		return "ノービス";

	case JOB_ID_SWORDMAN:
		return "ソードマン";
	case JOB_ID_THIEF:
		return "シーフ";
	case JOB_ID_ACOLYTE:
		return "アコライト";
	case JOB_ID_ARCHER:
		return "アーチャー";
	case JOB_ID_MAGICIAN:
		return "マジシャン";
	case JOB_ID_MARCHANT:
		return "マーチャント";

	case JOB_ID_KNIGHT:
		return "ナイト";
	case JOB_ID_ASSASIN:
		return "アサシン";
	case JOB_ID_PRIEST:
		return "プリースト";
	case JOB_ID_HUNTER:
		return "ハンター";
	case JOB_ID_WIZARD:
		return "ウィザード";
	case JOB_ID_BLACKSMITH:
		return "ブラックスミス";
	case JOB_ID_CRUSADER:
		return "クルセイダー";
	case JOB_ID_ROGUE:
		return "ローグ";
	case JOB_ID_MONK:
		return "モンク";
	case JOB_ID_BARD:
		return "バード";
	case JOB_ID_DANCER:
		return "ダンサー";
	case JOB_ID_SAGE:
		return "セージ";
	case JOB_ID_ALCHEMIST:
		return "アルケミスト";

	case JOB_ID_HI_NOVICE:
		return "ハイ ノービス";

	case JOB_ID_HI_SWORDMAN:
		return "ハイ ソードマン";
	case JOB_ID_HI_THIEF:
		return "ハイ シーフ";
	case JOB_ID_HI_ACOLYTE:
		return "ハイ アコライト";
	case JOB_ID_HI_ARCHER:
		return "ハイ アーチャー";
	case JOB_ID_HI_MAGICIAN:
		return "ハイ マジシャン";
	case JOB_ID_HI_MARCHANT:
		return "ハイ マーチャント";

	case JOB_ID_LORDKNIGHT:
		return "ロードナイト";
	case JOB_ID_ASSASINCROSS:
		return "アサシンクロス";
	case JOB_ID_HIGHPRIEST:
		return "ハイプリースト";
	case JOB_ID_SNIPER:
		return "スナイパー";
	case JOB_ID_HIGHWIZARD:
		return "ハイウィザード";
	case JOB_ID_WHITESMITH:
		return "ホワイトスミス";
	case JOB_ID_PALADIN:
		return "パラディン";
	case JOB_ID_CHASER:
		return "チェイサー";
	case JOB_ID_CHAMPION:
		return "チャンピオン";
	case JOB_ID_CROWN:
		return "クラウン";
	case JOB_ID_ZYPSY:
		return "ジプシー";
	case JOB_ID_PROFESSOR:
		return "プロフェッサー";
	case JOB_ID_CREATOR:
		return "クリエイター";

	case JOB_ID_TAEGWON:
		return "テコン";
	case JOB_ID_STARGRADIATOR:
		return "拳聖";
	case JOB_ID_SOULLINKER:
		return "ソウルリンカー";
	case JOB_ID_NINJA:
		return "忍者";
	case JOB_ID_GUNSLINGER:
		return "ガンスリンガー";

	case JOB_ID_SUPERNOVICE:
		return "スーパーノービス";
	case JOB_ID_SUPERNOVICE_PLUS:
		return "スーパーノービス＋";

	case JOB_ID_RUNEKNIGHT:
		return "ルーンナイト";
	case JOB_ID_GILOTINCROSS:
		return "ギロチンクロス";
	case JOB_ID_ARCBISHOP:
		return "アークビショップ";
	case JOB_ID_RANGER:
		return "レンジャー";
	case JOB_ID_WARLOCK:
		return "ウォーロック";
	case JOB_ID_MECHANIC:
		return "メカニック";
	case JOB_ID_ROYALGUARD:
		return "ロイヤルガード";
	case JOB_ID_SHADOWCHASER:
		return "シャドウチェイサー";
	case JOB_ID_SHURA:
		return "修羅";
	case JOB_ID_MINSTREL:
		return "ミンストレル";
	case JOB_ID_WANDERER:
		return "ワンダラー";
	case JOB_ID_SORCERER:
		return "ソーサラー";
	case JOB_ID_GENETIC:
		return "ジェネティック";

	case JOB_ID_KAGERO:
		return "影狼";
	case JOB_ID_OBORO:
		return "朧";
	case JOB_ID_REBELLION:
		return "リベリオン";

	}

	return "ニート";
}





// 職業系統
JOB_SERIES_ID_NOVICE		= 0;
JOB_SERIES_ID_SUPERNOVICE	= 20;

JOB_SERIES_ID_SWORDMAN		= 1;
JOB_SERIES_ID_THIEF			= 2;
JOB_SERIES_ID_ACOLYTE		= 3;
JOB_SERIES_ID_ARCHER		= 4;
JOB_SERIES_ID_MAGICIAN		= 5;
JOB_SERIES_ID_MERCHANT		= 6;

JOB_SERIES_ID_KNIGHT		= 7;
JOB_SERIES_ID_ASSASIN		= 8;
JOB_SERIES_ID_PRIEST		= 9;
JOB_SERIES_ID_HUNTER		= 10;
JOB_SERIES_ID_WIZARD		= 11;
JOB_SERIES_ID_BLACKSMITH	= 12;
JOB_SERIES_ID_CRUSADER		= 13;
JOB_SERIES_ID_ROGUE			= 14;
JOB_SERIES_ID_MONK			= 15;
JOB_SERIES_ID_BARD			= 16;
JOB_SERIES_ID_DANCER		= 17;
JOB_SERIES_ID_SAGE			= 18;
JOB_SERIES_ID_ALCHEMIST		= 19;

JOB_SERIES_ID_TAEGKUON		= 41;
JOB_SERIES_ID_NINJA			= 44;
JOB_SERIES_ID_GUNSLINGER	= 45;





/**
 * 一次職業系統を取得する.
 * @return 職業系統ＩＤ（０～
 */
function GetLowerJobSeriesID(jobID){

	// 一次職の場合は、そのまま返す
	if(jobID <= 6) return jobID;

	// ノービス系
	if(jobID == 20 || jobID == 61) return 0;

	// 転生一次職
	if(34 <= jobID && jobID <= 40) return (jobID - 34);

	// 上位職
	if(jobID == 7 || jobID == 13 || jobID == 21 || jobID == 27 || jobID == 46 || jobID == 52) return 1;
	if(jobID == 8 || jobID == 14 || jobID == 22 || jobID == 28 || jobID == 47 || jobID == 53) return 2;
	if(jobID == 9 || jobID == 15 || jobID == 23 || jobID == 29 || jobID == 48 || jobID == 54) return 3;
	if(jobID == 10 || jobID == 16 || jobID == 17 || jobID == 24 || jobID == 30 || jobID == 31 || jobID == 49 || jobID == 55 || jobID == 56) return 4;
	if(jobID == 11 || jobID == 18 || jobID == 25 || jobID == 32 || jobID == 50 || jobID == 57) return 5;
	if(jobID == 12 || jobID == 19 || jobID == 26 || jobID == 33 || jobID == 51 || jobID == 58) return 6;

	// テコン系
	if(jobID == 41 || jobID == 42 || jobID == 43) return 41;

	// 忍者系
	if(jobID == 44 || jobID == 59 || jobID == 60) return 44;

	// ガンスリンガー系
	if(jobID == 45 || jobID == 62) return 45;

	// TODO : 謎
	return 7;
}

/**
 * 二次職業系統を取得する.
 * @return 職業系統ＩＤ（０～
 */
function GetHigherJobSeriesID(jobID) {
	if(jobID == 7 || jobID == 21 || jobID == 46) return 7;
	if(jobID == 8 || jobID == 22 || jobID == 47) return 8;
	if(jobID == 9 || jobID == 23 || jobID == 48) return 9;
	if(jobID == 10 || jobID == 24 || jobID == 49) return 10;
	if(jobID == 11 || jobID == 25 || jobID == 50) return 11;
	if(jobID == 12 || jobID == 26 || jobID == 51) return 12;
	if(jobID == 13 || jobID == 27 || jobID == 52) return 13;
	if(jobID == 14 || jobID == 28 || jobID == 53) return 14;
	if(jobID == 15 || jobID == 29 || jobID == 54) return 15;
	if(jobID == 16 || jobID == 30 || jobID == 55) return 16;
	if(jobID == 17 || jobID == 31 || jobID == 56) return 17;
	if(jobID == 18 || jobID == 32 || jobID == 57) return 18;
	if(jobID == 19 || jobID == 33 || jobID == 58) return 19;
	if(jobID == 20 || jobID == 61) return 20;
	return 0;
}





/**
 * ベースレベルの最小値を取得する.
 * @param jobId ジョブＩＤ
 */
function GetBaseLevelMin(jobId) {

	// 最小レベルの設定
	switch (jobId) {
	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:
		return 90;

	case JOB_ID_KAGERO:
	case JOB_ID_OBORO:
	case JOB_ID_SUPERNOVICE_PLUS:
	case JOB_ID_REBELLION:
		return 99;

	case JOB_ID_SUPERNOVICE:
		return 45;

	default:
		return 1;
	}

	return 1;
}

/**
 * ベースレベルの最大値を取得する.
 * @param jobId ジョブＩＤ
 */
function GetBaseLevelMax(jobId) {

	// 最大レベルの設定
	switch (jobId) {
	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:
	case JOB_ID_KAGERO:
	case JOB_ID_OBORO:
	case JOB_ID_REBELLION:
		return 165;

	case JOB_ID_SUPERNOVICE_PLUS:
		return 160;

	default:
		return 99;
	}

	return 1;
}

/**
 * ジョブレベルの最大値を取得する.
 * @param jobId ジョブＩＤ
 */
function GetJobLevelMax(jobId) {

	switch (jobId) {
	case JOB_ID_NOVICE:
	case JOB_ID_HI_NOVICE:
		return 10;

	case JOB_ID_SWORDMAN:
	case JOB_ID_THIEF:
	case JOB_ID_ACOLYTE:
	case JOB_ID_ARCHER:
	case JOB_ID_MAGICIAN:
	case JOB_ID_MARCHANT:
	case JOB_ID_KNIGHT:
	case JOB_ID_ASSASIN:
	case JOB_ID_PRIEST:
	case JOB_ID_HUNTER:
	case JOB_ID_WIZARD:
	case JOB_ID_BLACKSMITH:
	case JOB_ID_CRUSADER:
	case JOB_ID_ROGUE:
	case JOB_ID_MONK:
	case JOB_ID_BARD:
	case JOB_ID_DANCER:
	case JOB_ID_SAGE:
	case JOB_ID_ALCHEMIST:
	case JOB_ID_HI_SWORDMAN:
	case JOB_ID_HI_THIEF:
	case JOB_ID_HI_ACOLYTE:
	case JOB_ID_HI_ARCHER:
	case JOB_ID_HI_MAGICIAN:
	case JOB_ID_HI_MARCHANT:
	case JOB_ID_TAEGWON:
	case JOB_ID_STARGRADIATOR:
	case JOB_ID_SOULLINKER:
	case JOB_ID_SUPERNOVICE_PLUS:
		return 50;

	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:
	case JOB_ID_KAGERO:
	case JOB_ID_OBORO:
	case JOB_ID_REBELLION:
		return 60;

	case JOB_ID_LORDKNIGHT:
	case JOB_ID_ASSASINCROSS:
	case JOB_ID_HIGHPRIEST:
	case JOB_ID_SNIPER:
	case JOB_ID_HIGHWIZARD:
	case JOB_ID_WHITESMITH:
	case JOB_ID_PALADIN:
	case JOB_ID_CHASER:
	case JOB_ID_CHAMPION:
	case JOB_ID_CROWN:
	case JOB_ID_ZYPSY:
	case JOB_ID_PROFESSOR:
	case JOB_ID_CREATOR:
	case JOB_ID_NINJA:
	case JOB_ID_GUNSLINGER:
		return 70;

	case JOB_ID_SUPERNOVICE:
		return 99;
	}

	return 1;
}



/**
 * ステータスの最大値を取得する.
 * @param jobId ジョブＩＤ
 */
function GetStatusMax(jobId) {

	switch (jobId) {
	case JOB_ID_SUPERNOVICE_PLUS:
		return 125;

	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:
	case JOB_ID_KAGERO:
	case JOB_ID_OBORO:
	case JOB_ID_REBELLION:
		return 130;

	}

	return 99;
}




/**
 * 転生フラグを取得する.
 * @param jobId ジョブＩＤ
 */
function IsReincarnatedJob(jobId) {

	switch (jobId) {

	case JOB_ID_HI_NOVICE:
	case JOB_ID_HI_SWORDMAN:
	case JOB_ID_HI_THIEF:
	case JOB_ID_HI_ACOLYTE:
	case JOB_ID_HI_ARCHER:
	case JOB_ID_HI_MAGICIAN:
	case JOB_ID_HI_MARCHANT:

	case JOB_ID_LORDKNIGHT:
	case JOB_ID_ASSASINCROSS:
	case JOB_ID_HIGHPRIEST:
	case JOB_ID_SNIPER:
	case JOB_ID_HIGHWIZARD:
	case JOB_ID_WHITESMITH:
	case JOB_ID_PALADIN:
	case JOB_ID_CHASER:
	case JOB_ID_CHAMPION:
	case JOB_ID_CROWN:
	case JOB_ID_ZYPSY:
	case JOB_ID_PROFESSOR:
	case JOB_ID_CREATOR:

	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:

		return true;

	}

	return false;
}





//================================================================================================
//================================================================================================
//====
//==== ジョブボーナス定義
//====
//================================================================================================
//================================================================================================
G_JOB_BONUS_DATA = Array();

// ノービス
var JobBonusData = [
];
G_JOB_BONUS_DATA[JOB_ID_NOVICE] = JobBonusData;


// ソードマン
JobBonusData = [
	2,		PARAM_STR
	,6,		PARAM_VIT
	,10,	PARAM_DEX
	,14,	PARAM_STR
	,18,	PARAM_VIT
	,22,	PARAM_DEX
	,26,	PARAM_LUK
	,30,	PARAM_AGI
	,33,	PARAM_STR
	,36,	PARAM_DEX
	,38,	PARAM_VIT
	,40,	PARAM_STR
	,42,	PARAM_VIT
	,44,	PARAM_LUK
	,46,	PARAM_AGI
	,47,	PARAM_STR
	,49,	PARAM_STR
	,50,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_SWORDMAN] = JobBonusData;


// シーフ
JobBonusData = [
	2,		PARAM_AGI
	,6,		PARAM_STR
	,10,	PARAM_DEX
	,14,	PARAM_VIT
	,18,	PARAM_INT
	,22,	PARAM_DEX
	,26,	PARAM_LUK
	,30,	PARAM_STR
	,33,	PARAM_AGI
	,36,	PARAM_AGI
	,38,	PARAM_STR
	,40,	PARAM_LUK
	,42,	PARAM_DEX
	,44,	PARAM_VIT
	,46,	PARAM_LUK
	,47,	PARAM_STR
	,49,	PARAM_DEX
	,50,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_THIEF] = JobBonusData;


// アコライト
JobBonusData = [
	2,		PARAM_LUK
	,6,		PARAM_VIT
	,10,	PARAM_INT
	,14,	PARAM_DEX
	,18,	PARAM_LUK
	,22,	PARAM_AGI
	,26,	PARAM_STR
	,30,	PARAM_VIT
	,33,	PARAM_INT
	,36,	PARAM_DEX
	,38,	PARAM_LUK
	,40,	PARAM_AGI
	,42,	PARAM_STR
	,44,	PARAM_VIT
	,46,	PARAM_INT
	,47,	PARAM_DEX
	,49,	PARAM_STR
	,50,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_ACOLYTE] = JobBonusData;


// アーチャー
JobBonusData = [
	2,		PARAM_DEX
	,6,		PARAM_STR
	,10,	PARAM_INT
	,14,	PARAM_DEX
	,18,	PARAM_DEX
	,22,	PARAM_LUK
	,26,	PARAM_AGI
	,30,	PARAM_DEX
	,33,	PARAM_AGI
	,36,	PARAM_DEX
	,38,	PARAM_STR
	,40,	PARAM_STR
	,42,	PARAM_DEX
	,44,	PARAM_LUK
	,46,	PARAM_VIT
	,47,	PARAM_INT
	,49,	PARAM_AGI
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_ARCHER] = JobBonusData;


// マジシャン
JobBonusData = [
	2,		PARAM_INT
	,6,		PARAM_DEX
	,10,	PARAM_DEX
	,14,	PARAM_INT
	,18,	PARAM_AGI
	,22,	PARAM_INT
	,26,	PARAM_AGI
	,30,	PARAM_LUK
	,33,	PARAM_INT
	,36,	PARAM_DEX
	,38,	PARAM_INT
	,40,	PARAM_AGI
	,42,	PARAM_LUK
	,44,	PARAM_INT
	,46,	PARAM_INT
	,47,	PARAM_AGI
	,49,	PARAM_LUK
	,50,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_MAGICIAN] = JobBonusData;


// マーチャント
JobBonusData = [
	2,		PARAM_VIT
	,6,		PARAM_DEX
	,10,	PARAM_STR
	,14,	PARAM_DEX
	,18,	PARAM_VIT
	,22,	PARAM_STR
	,26,	PARAM_INT
	,30,	PARAM_VIT
	,33,	PARAM_AGI
	,36,	PARAM_LUK
	,38,	PARAM_DEX
	,40,	PARAM_STR
	,42,	PARAM_DEX
	,44,	PARAM_STR
	,46,	PARAM_LUK
	,47,	PARAM_VIT
	,49,	PARAM_STR
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_MARCHANT] = JobBonusData;


// ナイト
JobBonusData = [
	1,		PARAM_VIT
	,3,		PARAM_VIT
	,4,		PARAM_STR
	,5,		PARAM_LUK
	,8,		PARAM_VIT
	,10,	PARAM_STR
	,11,	PARAM_DEX
	,12,	PARAM_VIT
	,13,	PARAM_AGI
	,15,	PARAM_STR
	,17,	PARAM_VIT
	,18,	PARAM_VIT
	,19,	PARAM_DEX
	,20,	PARAM_LUK
	,21,	PARAM_STR
	,23,	PARAM_VIT
	,27,	PARAM_STR
	,28,	PARAM_LUK
	,29,	PARAM_VIT
	,31,	PARAM_DEX
	,33,	PARAM_STR
	,36,	PARAM_VIT
	,37,	PARAM_LUK
	,38,	PARAM_AGI
	,40,	PARAM_DEX
	,43,	PARAM_VIT
	,46,	PARAM_STR
	,47,	PARAM_STR
	,48,	PARAM_DEX
	,49,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_KNIGHT] = JobBonusData;


// アサシン
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_AGI
	,3,		PARAM_AGI
	,4,		PARAM_INT
	,6,		PARAM_VIT
	,8,		PARAM_VIT
	,9,		PARAM_DEX
	,11,	PARAM_STR
	,14,	PARAM_INT
	,15,	PARAM_AGI
	,16,	PARAM_AGI
	,17,	PARAM_AGI
	,18,	PARAM_AGI
	,19,	PARAM_AGI
	,20,	PARAM_AGI
	,21,	PARAM_AGI
	,24,	PARAM_DEX
	,25,	PARAM_STR
	,27,	PARAM_STR
	,30,	PARAM_DEX
	,31,	PARAM_DEX
	,32,	PARAM_STR
	,38,	PARAM_INT
	,40,	PARAM_DEX
	,41,	PARAM_DEX
	,42,	PARAM_INT
	,45,	PARAM_STR
	,46,	PARAM_DEX
	,48,	PARAM_STR
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_ASSASIN] = JobBonusData;


// プリースト
JobBonusData = [
	1,		PARAM_LUK
	,3, 	PARAM_LUK
	,4,		PARAM_STR
	,6,		PARAM_AGI
	,7,		PARAM_VIT
	,8,		PARAM_INT
	,9,		PARAM_INT
	,10,	PARAM_LUK
	,11,	PARAM_STR
	,14,	PARAM_VIT
	,16,	PARAM_DEX
	,17,	PARAM_STR
	,20,	PARAM_DEX
	,21,	PARAM_LUK
	,22,	PARAM_INT
	,25,	PARAM_DEX
	,27,	PARAM_STR
	,29,	PARAM_AGI
	,31,	PARAM_LUK
	,32,	PARAM_DEX
	,34,	PARAM_VIT
	,35,	PARAM_STR
	,36,	PARAM_VIT
	,37,	PARAM_AGI
	,39,	PARAM_LUK
	,42,	PARAM_INT
	,43,	PARAM_INT
	,45,	PARAM_VIT
	,48,	PARAM_AGI
	,50,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_PRIEST] = JobBonusData;


// ハンター
JobBonusData = [
	1,		PARAM_DEX
	,3,		PARAM_INT
	,4, 	PARAM_DEX
	,5,		PARAM_STR
	,7,		PARAM_LUK
	,8,		PARAM_DEX
	,10,	PARAM_STR
	,11,	PARAM_STR
	,12,	PARAM_AGI
	,14,	PARAM_DEX
	,15,	PARAM_LUK
	,17,	PARAM_VIT
	,19,	PARAM_AGI
	,20,	PARAM_AGI
	,21,	PARAM_DEX
	,23,	PARAM_VIT
	,27,	PARAM_DEX
	,29,	PARAM_LUK
	,31,	PARAM_AGI
	,33,	PARAM_DEX
	,34,	PARAM_INT
	,38,	PARAM_DEX
	,39,	PARAM_AGI
	,41,	PARAM_INT
	,42,	PARAM_LUK
	,43,	PARAM_DEX
	,44,	PARAM_STR
	,46,	PARAM_INT
	,47,	PARAM_AGI
	,49,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_HUNTER] = JobBonusData;


// ウィザード
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_DEX
	,4,		PARAM_INT
	,5,		PARAM_DEX
	,6,		PARAM_AGI
	,9,		PARAM_INT
	,10,	PARAM_AGI
	,12,	PARAM_STR
	,13,	PARAM_DEX
	,15,	PARAM_LUK
	,18,	PARAM_INT
	,22,	PARAM_INT
	,24,	PARAM_AGI
	,26,	PARAM_DEX
	,29,	PARAM_INT
	,31,	PARAM_INT
	,32,	PARAM_DEX
	,33,	PARAM_INT
	,34,	PARAM_AGI
	,36,	PARAM_LUK
	,38,	PARAM_VIT
	,39,	PARAM_DEX
	,40,	PARAM_INT
	,41,	PARAM_AGI
	,43,	PARAM_AGI
	,45,	PARAM_INT
	,46,	PARAM_AGI
	,47,	PARAM_AGI
	,48,	PARAM_INT
	,50,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_WIZARD] = JobBonusData;


// ブラックスミス
JobBonusData = [
	1,		PARAM_DEX
	,3,		PARAM_STR
	,4,		PARAM_DEX
	,5,		PARAM_DEX
	,7,		PARAM_VIT
	,8,		PARAM_STR
	,9,		PARAM_DEX
	,11,	PARAM_LUK
	,12,	PARAM_DEX
	,13,	PARAM_VIT
	,16,	PARAM_STR
	,19,	PARAM_DEX
	,20,	PARAM_VIT
	,21,	PARAM_INT
	,23,	PARAM_STR
	,26,	PARAM_DEX
	,28,	PARAM_DEX
	,29,	PARAM_AGI
	,31,	PARAM_STR
	,32,	PARAM_VIT
	,34,	PARAM_INT
	,36,	PARAM_DEX
	,37,	PARAM_VIT
	,38,	PARAM_AGI
	,39,	PARAM_DEX
	,40,	PARAM_DEX
	,44,	PARAM_STR
	,46,	PARAM_LUK
	,47,	PARAM_DEX
	,49,	PARAM_VIT
];
G_JOB_BONUS_DATA[JOB_ID_BLACKSMITH] = JobBonusData;


// クルセイダー
JobBonusData = [
	1,		PARAM_LUK
	,2,		PARAM_LUK
	,3,		PARAM_LUK
	,4,		PARAM_LUK
	,5,		PARAM_LUK
	,7,		PARAM_STR
	,9,		PARAM_INT
	,11,	PARAM_STR
	,12,	PARAM_VIT
	,14,	PARAM_DEX
	,15,	PARAM_VIT
	,17,	PARAM_STR
	,20,	PARAM_INT
	,21,	PARAM_INT
	,22,	PARAM_VIT
	,23,	PARAM_STR
	,25,	PARAM_STR
	,28,	PARAM_DEX
	,30,	PARAM_AGI
	,32,	PARAM_STR
	,34,	PARAM_DEX
	,35,	PARAM_INT
	,36,	PARAM_AGI
	,38,	PARAM_INT
	,40,	PARAM_VIT
	,41,	PARAM_VIT
	,44,	PARAM_INT
	,46,	PARAM_VIT
	,48,	PARAM_STR
	,50,	PARAM_VIT
];
G_JOB_BONUS_DATA[JOB_ID_CRUSADER] = JobBonusData;


// ローグ
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_VIT
	,3,		PARAM_DEX
	,5,		PARAM_STR
	,6,		PARAM_VIT
	,7,		PARAM_AGI
	,9,		PARAM_VIT
	,11,	PARAM_DEX
	,14,	PARAM_VIT
	,15,	PARAM_VIT
	,16,	PARAM_AGI
	,18,	PARAM_DEX
	,20,	PARAM_DEX
	,23,	PARAM_AGI
	,25,	PARAM_STR
	,26,	PARAM_VIT
	,27,	PARAM_STR
	,29,	PARAM_AGI
	,30,	PARAM_STR
	,33,	PARAM_DEX
	,34,	PARAM_DEX
	,36,	PARAM_STR
	,38,	PARAM_INT
	,39,	PARAM_AGI
	,42,	PARAM_STR
	,43,	PARAM_INT
	,45,	PARAM_AGI
	,47,	PARAM_INT
	,48,	PARAM_INT
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_ROGUE] = JobBonusData;


// モンク
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_STR
	,4,		PARAM_DEX
	,6,		PARAM_AGI
	,7,		PARAM_VIT
	,10,	PARAM_AGI
	,12,	PARAM_STR
	,13,	PARAM_STR
	,14,	PARAM_LUK
	,16,	PARAM_INT
	,18,	PARAM_AGI
	,20,	PARAM_VIT
	,21,	PARAM_AGI
	,22,	PARAM_DEX
	,23,	PARAM_AGI
	,25,	PARAM_VIT
	,26,	PARAM_STR
	,27,	PARAM_STR
	,30,	PARAM_DEX
	,32,	PARAM_LUK
	,33,	PARAM_VIT
	,35,	PARAM_AGI
	,38,	PARAM_INT
	,40,	PARAM_LUK
	,41,	PARAM_VIT
	,43,	PARAM_DEX
	,44,	PARAM_AGI
	,46,	PARAM_VIT
	,49,	PARAM_STR
	,50,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_MONK] = JobBonusData;


// バード
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_AGI
	,3,		PARAM_STR
	,5,		PARAM_INT
	,6,		PARAM_LUK
	,7,		PARAM_DEX
	,9,		PARAM_LUK
	,10,	PARAM_AGI
	,11,	PARAM_AGI
	,13,	PARAM_INT
	,15,	PARAM_DEX
	,16,	PARAM_DEX
	,17,	PARAM_VIT
	,19,	PARAM_DEX
	,20,	PARAM_LUK
	,21,	PARAM_INT
	,24,	PARAM_AGI
	,28,	PARAM_STR
	,30,	PARAM_AGI
	,32,	PARAM_DEX
	,33,	PARAM_VIT
	,35,	PARAM_AGI
	,38,	PARAM_DEX
	,40,	PARAM_INT
	,41,	PARAM_LUK
	,43,	PARAM_VIT
	,46,	PARAM_DEX
	,47,	PARAM_INT
	,48,	PARAM_AGI
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_BARD] = JobBonusData;


// ダンサー
JobBonusData = [
	1,		PARAM_LUK
	,2,		PARAM_AGI
	,3,		PARAM_STR
	,5,		PARAM_INT
	,6,		PARAM_DEX
	,7,		PARAM_LUK
	,9,		PARAM_DEX
	,10,	PARAM_AGI
	,11,	PARAM_AGI
	,13,	PARAM_INT
	,15,	PARAM_LUK
	,16,	PARAM_DEX
	,17,	PARAM_VIT
	,19,	PARAM_LUK
	,20,	PARAM_DEX
	,21,	PARAM_INT
	,24,	PARAM_AGI
	,28,	PARAM_STR
	,30,	PARAM_AGI
	,32,	PARAM_LUK
	,33,	PARAM_VIT
	,35,	PARAM_AGI
	,38,	PARAM_LUK
	,40,	PARAM_INT
	,41,	PARAM_DEX
	,43,	PARAM_VIT
	,46,	PARAM_LUK
	,47,	PARAM_INT
	,48,	PARAM_AGI
	,50,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_DANCER] = JobBonusData;


// セージ
JobBonusData = [
	1,		PARAM_INT
	,3,		PARAM_AGI
	,4,		PARAM_VIT
	,6,		PARAM_AGI
	,8,		PARAM_INT
	,11,	PARAM_VIT
	,13,	PARAM_AGI
	,15,	PARAM_INT
	,17,	PARAM_LUK
	,18,	PARAM_VIT
	,20,	PARAM_DEX
	,22,	PARAM_AGI
	,24,	PARAM_INT
	,25,	PARAM_DEX
	,27,	PARAM_DEX
	,30,	PARAM_INT
	,32,	PARAM_DEX
	,33,	PARAM_AGI
	,35,	PARAM_LUK
	,37,	PARAM_INT
	,38,	PARAM_INT
	,39,	PARAM_DEX
	,40,	PARAM_LUK
	,42,	PARAM_STR
	,44,	PARAM_STR
	,45,	PARAM_INT
	,46,	PARAM_STR
	,47,	PARAM_STR
	,48,	PARAM_STR
	,50,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_SAGE] = JobBonusData;


// アルケミスト
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_DEX
	,3,		PARAM_DEX
	,6,		PARAM_STR
	,8,		PARAM_DEX
	,9,		PARAM_INT
	,11,	PARAM_AGI
	,13,	PARAM_DEX
	,14,	PARAM_AGI
	,15,	PARAM_STR
	,17,	PARAM_INT
	,19,	PARAM_DEX
	,20,	PARAM_VIT
	,21,	PARAM_DEX
	,23,	PARAM_INT
	,24,	PARAM_INT
	,25,	PARAM_DEX
	,26,	PARAM_STR
	,28,	PARAM_DEX
	,29,	PARAM_INT
	,31,	PARAM_VIT
	,32,	PARAM_DEX
	,34,	PARAM_STR
	,36,	PARAM_VIT
	,38,	PARAM_INT
	,40,	PARAM_AGI
	,43,	PARAM_STR
	,45,	PARAM_AGI
	,49,	PARAM_AGI
	,50,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_ALCHEMIST] = JobBonusData;


// スーパーノービス
JobBonusData = [
	1,		PARAM_STR
	,3,		PARAM_AGI
	,5,		PARAM_VIT
	,7,		PARAM_INT
	,9,		PARAM_DEX
	,11,	PARAM_LUK
	,13,	PARAM_STR
	,15,	PARAM_AGI
	,17,	PARAM_VIT
	,19,	PARAM_INT
	,21,	PARAM_DEX
	,23,	PARAM_LUK
	,25,	PARAM_STR
	,27,	PARAM_AGI
	,29,	PARAM_VIT
	,31,	PARAM_INT
	,33,	PARAM_DEX
	,35,	PARAM_LUK
	,37,	PARAM_STR
	,39,	PARAM_AGI
	,41,	PARAM_VIT
	,43,	PARAM_INT
	,45,	PARAM_DEX
	,47,	PARAM_LUK
	,49,	PARAM_STR
	,52,	PARAM_AGI
	,56,	PARAM_VIT
	,60,	PARAM_INT
	,64,	PARAM_DEX
	,68,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_SUPERNOVICE] = JobBonusData;


// ロードナイト
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_AGI
	,2,		PARAM_LUK
	,4,		PARAM_DEX
	,5,		PARAM_VIT
	,6,		PARAM_STR
	,7,		PARAM_STR
	,8,		PARAM_STR
	,10,	PARAM_AGI
	,11,	PARAM_DEX
	,12,	PARAM_VIT
	,13,	PARAM_INT
	,14,	PARAM_AGI
	,16,	PARAM_DEX
	,17,	PARAM_AGI
	,19,	PARAM_STR
	,22,	PARAM_VIT
	,25,	PARAM_STR
	,27,	PARAM_LUK
	,28,	PARAM_DEX
	,29,	PARAM_VIT
	,31,	PARAM_DEX
	,33,	PARAM_STR
	,36,	PARAM_DEX
	,37,	PARAM_AGI
	,38,	PARAM_LUK
	,40,	PARAM_VIT
	,41,	PARAM_STR
	,43,	PARAM_VIT
	,44,	PARAM_DEX
	,46,	PARAM_STR
	,47,	PARAM_STR
	,49,	PARAM_DEX
	,52,	PARAM_STR
	,53,	PARAM_AGI
	,56,	PARAM_STR
	,57,	PARAM_STR
	,58,	PARAM_VIT
	,60,	PARAM_AGI
	,62,	PARAM_DEX
	,64,	PARAM_STR
	,65,	PARAM_AGI
	,67,	PARAM_INT
	,68,	PARAM_VIT
	,70,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_LORDKNIGHT] = JobBonusData;


// アサシンクロス
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_STR
	,3,		PARAM_LUK
	,4,		PARAM_AGI
	,6,		PARAM_AGI
	,7,		PARAM_STR
	,8,		PARAM_LUK
	,9,		PARAM_VIT
	,10,	PARAM_DEX
	,12,	PARAM_STR
	,15,	PARAM_AGI
	,16,	PARAM_LUK
	,18,	PARAM_LUK
	,20,	PARAM_AGI
	,21,	PARAM_STR
	,23,	PARAM_DEX
	,24,	PARAM_AGI
	,25,	PARAM_AGI
	,26,	PARAM_LUK
	,29,	PARAM_STR
	,31,	PARAM_AGI
	,32,	PARAM_AGI
	,33,	PARAM_AGI
	,34,	PARAM_LUK
	,37,	PARAM_DEX
	,38,	PARAM_STR
	,39,	PARAM_DEX
	,42,	PARAM_AGI
	,43,	PARAM_DEX
	,46,	PARAM_AGI
	,47,	PARAM_VIT
	,48,	PARAM_LUK
	,50,	PARAM_STR
	,51,	PARAM_AGI
	,53,	PARAM_DEX
	,54,	PARAM_STR
	,56,	PARAM_AGI
	,57,	PARAM_DEX
	,61,	PARAM_DEX
	,62,	PARAM_AGI
	,64,	PARAM_DEX
	,65,	PARAM_LUK
	,66,	PARAM_STR
	,69,	PARAM_VIT
	,70,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_ASSASINCROSS] = JobBonusData;


// ハイプリースト
JobBonusData = [
	1,		PARAM_INT
	,3,		PARAM_AGI
	,4,		PARAM_VIT
	,5,		PARAM_STR
	,7,		PARAM_INT
	,8,		PARAM_AGI
	,11,	PARAM_INT
	,12,	PARAM_STR
	,13,	PARAM_DEX
	,16,	PARAM_DEX
	,19,	PARAM_AGI
	,20,	PARAM_INT
	,21,	PARAM_STR
	,22,	PARAM_VIT
	,23,	PARAM_INT
	,24,	PARAM_INT
	,26,	PARAM_DEX
	,28,	PARAM_DEX
	,29,	PARAM_AGI
	,30,	PARAM_VIT
	,31,	PARAM_STR
	,34,	PARAM_INT
	,37,	PARAM_DEX
	,38,	PARAM_STR
	,40,	PARAM_LUK
	,42,	PARAM_AGI
	,43,	PARAM_DEX
	,45,	PARAM_STR
	,46,	PARAM_DEX
	,47,	PARAM_INT
	,49,	PARAM_LUK
	,50,	PARAM_VIT
	,51,	PARAM_VIT
	,55,	PARAM_AGI
	,56,	PARAM_DEX
	,57,	PARAM_INT
	,58,	PARAM_VIT
	,60,	PARAM_STR
	,61,	PARAM_INT
	,62,	PARAM_DEX
	,65,	PARAM_AGI
	,66,	PARAM_INT
	,67,	PARAM_VIT
	,68,	PARAM_AGI
	,70,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_HIGHPRIEST] = JobBonusData;


// スナイパー
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_AGI
	,3,		PARAM_DEX
	,4,		PARAM_DEX
	,5,		PARAM_INT
	,6,		PARAM_AGI
	,8,		PARAM_STR
	,10,	PARAM_AGI
	,11,	PARAM_AGI
	,12,	PARAM_VIT
	,14,	PARAM_LUK
	,16,	PARAM_DEX
	,17,	PARAM_DEX
	,20,	PARAM_INT
	,21,	PARAM_AGI
	,22,	PARAM_DEX
	,24,	PARAM_STR
	,25,	PARAM_LUK
	,26,	PARAM_DEX
	,28,	PARAM_AGI
	,30,	PARAM_DEX
	,31,	PARAM_LUK
	,32,	PARAM_VIT
	,33,	PARAM_AGI
	,35,	PARAM_DEX
	,36,	PARAM_LUK
	,38,	PARAM_AGI
	,40,	PARAM_DEX
	,42,	PARAM_INT
	,43,	PARAM_AGI
	,45,	PARAM_STR
	,46,	PARAM_DEX
	,48,	PARAM_AGI
	,50,	PARAM_LUK
	,51,	PARAM_DEX
	,54,	PARAM_INT
	,55,	PARAM_VIT
	,57,	PARAM_LUK
	,58,	PARAM_AGI
	,60,	PARAM_DEX
	,61,	PARAM_STR
	,62,	PARAM_LUK
	,65,	PARAM_INT
	,69,	PARAM_DEX
	,70,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_SNIPER] = JobBonusData;


// ハイウィザード
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_DEX
	,3,		PARAM_VIT
	,5,		PARAM_INT
	,8,		PARAM_AGI
	,9,		PARAM_DEX
	,10,	PARAM_INT
	,12,	PARAM_LUK
	,14,	PARAM_INT
	,17,	PARAM_DEX
	,18,	PARAM_AGI
	,19,	PARAM_INT
	,20,	PARAM_STR
	,22,	PARAM_DEX
	,23,	PARAM_DEX
	,24,	PARAM_INT
	,26,	PARAM_AGI
	,28,	PARAM_INT
	,29,	PARAM_VIT
	,31,	PARAM_DEX
	,32,	PARAM_INT
	,34,	PARAM_AGI
	,37,	PARAM_INT
	,38,	PARAM_INT
	,39,	PARAM_INT
	,40,	PARAM_STR
	,41,	PARAM_LUK
	,43,	PARAM_DEX
	,46,	PARAM_INT
	,47,	PARAM_VIT
	,49,	PARAM_INT
	,50,	PARAM_AGI
	,53,	PARAM_VIT
	,55,	PARAM_INT
	,56,	PARAM_AGI
	,57,	PARAM_LUK
	,59,	PARAM_INT
	,60,	PARAM_STR
	,61,	PARAM_DEX
	,62,	PARAM_INT
	,65,	PARAM_AGI
	,66,	PARAM_VIT
	,67,	PARAM_DEX
	,69,	PARAM_AGI
	,70,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_HIGHWIZARD] = JobBonusData;


// ホワイトスミス
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_STR
	,3,		PARAM_STR
	,4,		PARAM_INT
	,6,		PARAM_DEX
	,7,		PARAM_AGI
	,8,		PARAM_LUK
	,9,		PARAM_VIT
	,12,	PARAM_DEX
	,13,	PARAM_VIT
	,15,	PARAM_INT
	,16,	PARAM_LUK
	,17,	PARAM_STR
	,19,	PARAM_AGI
	,20,	PARAM_AGI
	,22,	PARAM_INT
	,23,	PARAM_DEX
	,26,	PARAM_STR
	,28,	PARAM_LUK
	,29,	PARAM_VIT
	,31,	PARAM_AGI
	,32,	PARAM_DEX
	,33,	PARAM_STR
	,34,	PARAM_INT
	,36,	PARAM_AGI
	,38,	PARAM_DEX
	,39,	PARAM_LUK
	,41,	PARAM_DEX
	,44,	PARAM_LUK
	,45,	PARAM_LUK
	,47,	PARAM_DEX
	,48,	PARAM_VIT
	,50,	PARAM_INT
	,52,	PARAM_STR
	,55,	PARAM_DEX
	,56,	PARAM_DEX
	,58,	PARAM_AGI
	,60,	PARAM_VIT
	,61,	PARAM_INT
	,62,	PARAM_DEX
	,64,	PARAM_AGI
	,65,	PARAM_VIT
	,66,	PARAM_LUK
	,67,	PARAM_LUK
	,70,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_WHITESMITH] = JobBonusData;


// パラディン
JobBonusData = [
	1,		PARAM_VIT
	,2,		PARAM_STR
	,3,		PARAM_AGI
	,6,		PARAM_DEX
	,7,		PARAM_INT
	,8,		PARAM_AGI
	,9,		PARAM_VIT
	,10,	PARAM_STR
	,12,	PARAM_DEX
	,14,	PARAM_INT
	,15,	PARAM_VIT
	,16,	PARAM_AGI
	,17,	PARAM_DEX
	,18,	PARAM_STR
	,21,	PARAM_VIT
	,23,	PARAM_DEX
	,24,	PARAM_AGI
	,26,	PARAM_STR
	,29,	PARAM_INT
	,30,	PARAM_VIT
	,33,	PARAM_STR
	,36,	PARAM_DEX
	,37,	PARAM_AGI
	,39,	PARAM_LUK
	,40,	PARAM_STR
	,42,	PARAM_VIT
	,43,	PARAM_INT
	,45,	PARAM_DEX
	,48,	PARAM_STR
	,49,	PARAM_VIT
	,52,	PARAM_AGI
	,53,	PARAM_VIT
	,54,	PARAM_INT
	,55,	PARAM_STR
	,57,	PARAM_DEX
	,59,	PARAM_LUK
	,60,	PARAM_AGI
	,61,	PARAM_INT
	,63,	PARAM_VIT
	,64,	PARAM_STR
	,65,	PARAM_INT
	,67,	PARAM_LUK
	,68,	PARAM_DEX
	,69,	PARAM_VIT
	,70,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_PALADIN] = JobBonusData;


// チェイサー
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_AGI
	,4,		PARAM_LUK
	,5,		PARAM_INT
	,6,		PARAM_VIT
	,9,		PARAM_AGI
	,10,	PARAM_DEX
	,11,	PARAM_STR
	,12,	PARAM_AGI
	,15,	PARAM_VIT
	,16,	PARAM_DEX
	,17,	PARAM_DEX
	,20,	PARAM_LUK
	,21,	PARAM_AGI
	,22,	PARAM_STR
	,24,	PARAM_LUK
	,26,	PARAM_DEX
	,27,	PARAM_AGI
	,29,	PARAM_DEX
	,31,	PARAM_LUK
	,32,	PARAM_STR
	,34,	PARAM_AGI
	,37,	PARAM_DEX
	,38,	PARAM_DEX
	,41,	PARAM_AGI
	,42,	PARAM_VIT
	,43,	PARAM_STR
	,44,	PARAM_INT
	,45,	PARAM_AGI
	,47,	PARAM_STR
	,49,	PARAM_DEX
	,50,	PARAM_LUK
	,52,	PARAM_DEX
	,53,	PARAM_STR
	,56,	PARAM_DEX
	,57,	PARAM_INT
	,58,	PARAM_AGI
	,59,	PARAM_LUK
	,60,	PARAM_DEX
	,62,	PARAM_STR
	,63,	PARAM_VIT
	,64,	PARAM_AGI
	,66,	PARAM_DEX
	,67,	PARAM_STR
	,70,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_CHASER] = JobBonusData;


// チャンピオン
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_INT
	,3,		PARAM_VIT
	,4,		PARAM_AGI
	,6,		PARAM_DEX
	,9,		PARAM_STR
	,11,	PARAM_INT
	,12,	PARAM_AGI
	,13,	PARAM_LUK
	,15,	PARAM_VIT
	,16,	PARAM_DEX
	,17,	PARAM_STR
	,20,	PARAM_AGI
	,21,	PARAM_AGI
	,22,	PARAM_DEX
	,24,	PARAM_VIT
	,27,	PARAM_STR
	,29,	PARAM_AGI
	,30,	PARAM_DEX
	,33,	PARAM_INT
	,34,	PARAM_LUK
	,37,	PARAM_STR
	,38,	PARAM_DEX
	,39,	PARAM_VIT
	,42,	PARAM_VIT
	,44,	PARAM_DEX
	,45,	PARAM_AGI
	,46,	PARAM_LUK
	,47,	PARAM_INT
	,48,	PARAM_STR
	,50,	PARAM_DEX
	,52,	PARAM_AGI
	,53,	PARAM_DEX
	,56,	PARAM_INT
	,58,	PARAM_VIT
	,59,	PARAM_STR
	,60,	PARAM_DEX
	,62,	PARAM_AGI
	,64,	PARAM_INT
	,65,	PARAM_STR
	,66,	PARAM_STR
	,67,	PARAM_DEX
	,68,	PARAM_VIT
	,69,	PARAM_INT
	,70,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_CHAMPION] = JobBonusData;


// クラウン
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_DEX
	,4,		PARAM_AGI
	,5,		PARAM_STR
	,7,		PARAM_DEX
	,8,		PARAM_INT
	,9,		PARAM_AGI
	,10,	PARAM_STR
	,11,	PARAM_LUK
	,13,	PARAM_AGI
	,15,	PARAM_DEX
	,16,	PARAM_VIT
	,18,	PARAM_LUK
	,19,	PARAM_STR
	,21,	PARAM_INT
	,23,	PARAM_DEX
	,24,	PARAM_AGI
	,26,	PARAM_LUK
	,28,	PARAM_INT
	,30,	PARAM_DEX
	,32,	PARAM_AGI
	,33,	PARAM_STR
	,36,	PARAM_AGI
	,39,	PARAM_DEX
	,40,	PARAM_DEX
	,41,	PARAM_INT
	,43,	PARAM_DEX
	,45,	PARAM_STR
	,47,	PARAM_LUK
	,49,	PARAM_AGI
	,50,	PARAM_DEX
	,53,	PARAM_AGI
	,54,	PARAM_STR
	,56,	PARAM_DEX
	,57,	PARAM_DEX
	,58,	PARAM_AGI
	,59,	PARAM_VIT
	,61,	PARAM_DEX
	,62,	PARAM_STR
	,63,	PARAM_DEX
	,65,	PARAM_AGI
	,66,	PARAM_DEX
	,68,	PARAM_AGI
	,69,	PARAM_INT
	,70,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_CROWN] = JobBonusData;


// ジプシー
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_STR
	,4,		PARAM_AGI
	,6,		PARAM_STR
	,8,		PARAM_INT
	,9,		PARAM_DEX
	,11,	PARAM_AGI
	,12,	PARAM_AGI
	,13,	PARAM_AGI
	,14,	PARAM_DEX
	,15,	PARAM_DEX
	,17,	PARAM_VIT
	,18,	PARAM_DEX
	,20,	PARAM_STR
	,22,	PARAM_DEX
	,23,	PARAM_DEX
	,25,	PARAM_AGI
	,26,	PARAM_INT
	,27,	PARAM_LUK
	,28,	PARAM_DEX
	,31,	PARAM_AGI
	,33,	PARAM_DEX
	,35,	PARAM_STR
	,38,	PARAM_AGI
	,39,	PARAM_INT
	,41,	PARAM_DEX
	,43,	PARAM_DEX
	,45,	PARAM_DEX
	,47,	PARAM_AGI
	,49,	PARAM_DEX
	,50,	PARAM_STR
	,52,	PARAM_AGI
	,53,	PARAM_INT
	,54,	PARAM_VIT
	,57,	PARAM_AGI
	,58,	PARAM_DEX
	,60,	PARAM_INT
	,61,	PARAM_AGI
	,62,	PARAM_AGI
	,63,	PARAM_LUK
	,65,	PARAM_DEX
	,66,	PARAM_STR
	,67,	PARAM_AGI
	,69,	PARAM_DEX
	,70,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_ZYPSY] = JobBonusData;


// プロフェッサー
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_INT
	,3,		PARAM_AGI
	,5,		PARAM_STR
	,7,		PARAM_VIT
	,8,		PARAM_DEX
	,11,	PARAM_INT
	,12,	PARAM_AGI
	,14,	PARAM_INT
	,16,	PARAM_DEX
	,18,	PARAM_STR
	,20,	PARAM_DEX
	,21,	PARAM_LUK
	,22,	PARAM_INT
	,23,	PARAM_AGI
	,24,	PARAM_VIT
	,26,	PARAM_DEX
	,27,	PARAM_STR
	,29,	PARAM_DEX
	,30,	PARAM_INT
	,32,	PARAM_AGI
	,34,	PARAM_DEX
	,36,	PARAM_STR
	,37,	PARAM_DEX
	,38,	PARAM_INT
	,39,	PARAM_VIT
	,41,	PARAM_INT
	,43,	PARAM_AGI
	,45,	PARAM_STR
	,46,	PARAM_DEX
	,49,	PARAM_INT
	,50,	PARAM_AGI
	,52,	PARAM_DEX
	,54,	PARAM_AGI
	,55,	PARAM_DEX
	,56,	PARAM_STR
	,57,	PARAM_INT
	,60,	PARAM_AGI
	,62,	PARAM_DEX
	,63,	PARAM_VIT
	,64,	PARAM_INT
	,66,	PARAM_LUK
	,68,	PARAM_INT
	,69,	PARAM_AGI
	,70,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_PROFESSOR] = JobBonusData;


// クリエイター
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_LUK
	,5,		PARAM_AGI
	,6,		PARAM_STR
	,7,		PARAM_INT
	,8,		PARAM_LUK
	,9,		PARAM_VIT
	,10,	PARAM_DEX
	,13,	PARAM_INT
	,15,	PARAM_DEX
	,18,	PARAM_AGI
	,20,	PARAM_LUK
	,22,	PARAM_INT
	,23,	PARAM_DEX
	,25,	PARAM_LUK
	,27,	PARAM_AGI
	,30,	PARAM_INT
	,31,	PARAM_STR
	,33,	PARAM_VIT
	,34,	PARAM_LUK
	,35,	PARAM_DEX
	,38,	PARAM_AGI
	,41,	PARAM_DEX
	,42,	PARAM_DEX
	,43,	PARAM_DEX
	,45,	PARAM_LUK
	,46,	PARAM_INT
	,47,	PARAM_DEX
	,49,	PARAM_DEX
	,51,	PARAM_LUK
	,52,	PARAM_LUK
	,53,	PARAM_STR
	,54,	PARAM_AGI
	,56,	PARAM_DEX
	,57,	PARAM_DEX
	,59,	PARAM_INT
	,60,	PARAM_LUK
	,61,	PARAM_VIT
	,63,	PARAM_DEX
	,64,	PARAM_LUK
	,66,	PARAM_STR
	,67,	PARAM_AGI
	,68,	PARAM_INT
	,69,	PARAM_LUK
	,70,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_CREATOR] = JobBonusData;


// ノービスハイ
JobBonusData = [
	2,		PARAM_LUK
	,3,		PARAM_DEX
	,5,		PARAM_AGI
	,6,		PARAM_VIT
	,8,		PARAM_STR
	,9,		PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_HI_NOVICE] = JobBonusData;


// ソードマンハイ
JobBonusData = [
	2,		PARAM_STR
	,6,		PARAM_VIT
	,10,	PARAM_DEX
	,14,	PARAM_STR
	,18,	PARAM_VIT
	,22,	PARAM_DEX
	,26,	PARAM_LUK
	,30,	PARAM_AGI
	,33,	PARAM_STR
	,36,	PARAM_DEX
	,38,	PARAM_VIT
	,40,	PARAM_STR
	,42,	PARAM_VIT
	,44,	PARAM_LUK
	,46,	PARAM_AGI
	,47,	PARAM_STR
	,49,	PARAM_STR
	,50,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_HI_SWORDMAN] = JobBonusData;


// シーフハイ
JobBonusData = [
	2,		PARAM_AGI
	,6,		PARAM_STR
	,10,	PARAM_DEX
	,14,	PARAM_VIT
	,18,	PARAM_INT
	,22,	PARAM_DEX
	,26,	PARAM_LUK
	,30,	PARAM_STR
	,33,	PARAM_AGI
	,36,	PARAM_AGI
	,38,	PARAM_STR
	,40,	PARAM_LUK
	,42,	PARAM_DEX
	,44,	PARAM_VIT
	,46,	PARAM_LUK
	,47,	PARAM_STR
	,49,	PARAM_DEX
	,50,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_HI_THIEF] = JobBonusData;


// アコライトハイ
JobBonusData = [
	2,		PARAM_LUK
	,6,		PARAM_VIT
	,10,	PARAM_INT
	,14,	PARAM_DEX
	,18,	PARAM_LUK
	,22,	PARAM_AGI
	,26,	PARAM_STR
	,30,	PARAM_VIT
	,33,	PARAM_INT
	,36,	PARAM_DEX
	,38,	PARAM_LUK
	,40,	PARAM_AGI
	,42,	PARAM_STR
	,44,	PARAM_VIT
	,46,	PARAM_INT
	,47,	PARAM_DEX
	,49,	PARAM_STR
	,50,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_HI_ACOLYTE] = JobBonusData;


// アーチャーハイ
JobBonusData = [
	2,		PARAM_DEX
	,6,		PARAM_STR
	,10,	PARAM_INT
	,14,	PARAM_DEX
	,18,	PARAM_DEX
	,22,	PARAM_LUK
	,26,	PARAM_AGI
	,30,	PARAM_DEX
	,33,	PARAM_AGI
	,36,	PARAM_DEX
	,38,	PARAM_STR
	,40,	PARAM_STR
	,42,	PARAM_DEX
	,44,	PARAM_LUK
	,46,	PARAM_VIT
	,47,	PARAM_INT
	,49,	PARAM_AGI
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_HI_ARCHER] = JobBonusData;


// マジシャンハイ
JobBonusData = [
	2,		PARAM_INT
	,6,		PARAM_DEX
	,10,	PARAM_DEX
	,14,	PARAM_INT
	,18,	PARAM_AGI
	,22,	PARAM_INT
	,26,	PARAM_AGI
	,30,	PARAM_LUK
	,33,	PARAM_INT
	,36,	PARAM_DEX
	,38,	PARAM_INT
	,40,	PARAM_AGI
	,42,	PARAM_LUK
	,44,	PARAM_INT
	,46,	PARAM_INT
	,47,	PARAM_AGI
	,49,	PARAM_LUK
	,50,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_HI_MAGICIAN] = JobBonusData;


// マーチャントハイ
JobBonusData = [
	2,		PARAM_VIT
	,6,		PARAM_DEX
	,10,	PARAM_STR
	,14,	PARAM_DEX
	,18,	PARAM_VIT
	,22,	PARAM_STR
	,26,	PARAM_INT
	,30,	PARAM_VIT
	,33,	PARAM_AGI
	,36,	PARAM_LUK
	,38,	PARAM_DEX
	,40,	PARAM_STR
	,42,	PARAM_DEX
	,44,	PARAM_STR
	,46,	PARAM_LUK
	,47,	PARAM_VIT
	,49,	PARAM_STR
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_HI_MARCHANT] = JobBonusData;


// テコン
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_STR
	,3,		PARAM_STR
	,4,		PARAM_STR
	,5,		PARAM_STR
	,6,		PARAM_STR
	,10,	PARAM_DEX
	,11,	PARAM_DEX
	,12,	PARAM_DEX
	,13,	PARAM_DEX
	,14,	PARAM_DEX
	,15,	PARAM_DEX
	,20,	PARAM_AGI
	,21,	PARAM_AGI
	,22,	PARAM_AGI
	,23,	PARAM_AGI
	,24,	PARAM_AGI
	,25,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_TAEGWON] = JobBonusData;


// 拳聖
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_STR
	,3,		PARAM_STR
	,4,		PARAM_STR
	,5,		PARAM_STR
	,6,		PARAM_STR
	,7,		PARAM_STR
	,8,		PARAM_STR
	,9,		PARAM_STR
	,10,	PARAM_STR
	,11,	PARAM_STR
	,12,	PARAM_STR
	,20,	PARAM_DEX
	,21,	PARAM_DEX
	,22,	PARAM_DEX
	,23,	PARAM_DEX
	,24,	PARAM_DEX
	,25,	PARAM_DEX
	,39,	PARAM_AGI
	,40,	PARAM_AGI
	,41,	PARAM_AGI
	,42,	PARAM_AGI
	,43,	PARAM_AGI
	,44,	PARAM_AGI
	,45,	PARAM_AGI
	,46,	PARAM_AGI
	,47,	PARAM_AGI
	,48,	PARAM_AGI
	,49,	PARAM_AGI
	,50,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_STARGRADIATOR] = JobBonusData;


// ソウルリンカー
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_INT
	,3,		PARAM_INT
	,4,		PARAM_INT
	,5,		PARAM_INT
	,6,		PARAM_INT
	,7,		PARAM_INT
	,8,		PARAM_INT
	,9,		PARAM_INT
	,10,	PARAM_INT
	,11,	PARAM_INT
	,12,	PARAM_INT
	,20,	PARAM_VIT
	,21,	PARAM_VIT
	,22,	PARAM_VIT
	,23,	PARAM_VIT
	,24,	PARAM_VIT
	,25,	PARAM_VIT
	,39,	PARAM_DEX
	,40,	PARAM_DEX
	,41,	PARAM_DEX
	,42,	PARAM_DEX
	,43,	PARAM_DEX
	,44,	PARAM_DEX
	,45,	PARAM_DEX
	,46,	PARAM_DEX
	,47,	PARAM_DEX
	,48,	PARAM_DEX
	,49,	PARAM_DEX
	,50,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_SOULLINKER] = JobBonusData;


// 忍者
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_AGI
	,10,	PARAM_DEX
	,11,	PARAM_AGI
	,20,	PARAM_INT
	,21,	PARAM_AGI
	,22,	PARAM_DEX
	,29,	PARAM_INT
	,30,	PARAM_LUK
	,31,	PARAM_AGI
	,32,	PARAM_DEX
	,40,	PARAM_LUK
	,41,	PARAM_AGI
	,42,	PARAM_INT
	,43,	PARAM_DEX
	,50,	PARAM_INT
	,51,	PARAM_AGI
	,52,	PARAM_LUK
	,53,	PARAM_DEX
	,59,	PARAM_STR
	,60,	PARAM_VIT
	,61,	PARAM_AGI
	,62,	PARAM_INT
	,63,	PARAM_DEX
	,64,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_NINJA] = JobBonusData;


// ガンスリンガー
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_LUK
	,4,		PARAM_LUK
	,6,		PARAM_DEX
	,11,	PARAM_DEX
	,12,	PARAM_LUK
	,17,	PARAM_DEX
	,21,	PARAM_LUK
	,25,	PARAM_DEX
	,31,	PARAM_LUK
	,32,	PARAM_STR
	,35,	PARAM_DEX
	,41,	PARAM_STR
	,45,	PARAM_DEX
	,50,	PARAM_STR
	,51,	PARAM_LUK
	,52,	PARAM_INT
	,55,	PARAM_DEX
	,59,	PARAM_AGI
	,60,	PARAM_VIT
	,61,	PARAM_INT
	,62,	PARAM_DEX
	,63,	PARAM_LUK
	,64,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_GUNSLINGER] = JobBonusData;


// ルーンナイト
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_INT
	,3,		PARAM_DEX
	,4,		PARAM_VIT
	,5,		PARAM_INT
	,10,	PARAM_STR
	,11,	PARAM_STR
	,12,	PARAM_INT
	,13,	PARAM_INT
	,14,	PARAM_VIT
	,15,	PARAM_DEX
	,19,	PARAM_DEX
	,20,	PARAM_AGI
	,21,	PARAM_AGI
	,22,	PARAM_INT
	,23,	PARAM_VIT
	,24,	PARAM_DEX
	,30,	PARAM_INT
	,31,	PARAM_DEX
	,32,	PARAM_VIT
	,33,	PARAM_STR
	,39,	PARAM_INT
	,40,	PARAM_DEX
	,41,	PARAM_AGI
	,44,	PARAM_DEX
	,45,	PARAM_VIT
	,46,	PARAM_INT
	,47,	PARAM_LUK
	,48,	PARAM_LUK
	,49,	PARAM_LUK
	,50,	PARAM_INT
	,51,	PARAM_STR
	,53,	PARAM_AGI
	,55,	PARAM_DEX
	,57,	PARAM_LUK
	,59,	PARAM_VIT
	,60,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_RUNEKNIGHT] = JobBonusData;


// ギロチンクロス
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_DEX
	,4,		PARAM_STR
	,5,		PARAM_STR
	,9,		PARAM_STR
	,10,	PARAM_AGI
	,11,	PARAM_DEX
	,14,	PARAM_VIT
	,15,	PARAM_VIT
	,16,	PARAM_STR
	,19,	PARAM_VIT
	,20,	PARAM_STR
	,23,	PARAM_AGI
	,24,	PARAM_AGI
	,25,	PARAM_DEX
	,28,	PARAM_INT
	,29,	PARAM_INT
	,30,	PARAM_STR
	,31,	PARAM_VIT
	,35,	PARAM_AGI
	,36,	PARAM_DEX
	,37,	PARAM_DEX
	,41,	PARAM_INT
	,42,	PARAM_VIT
	,43,	PARAM_AGI
	,44,	PARAM_AGI
	,48,	PARAM_INT
	,49,	PARAM_DEX
	,50,	PARAM_DEX
	,51,	PARAM_LUK
	,52,	PARAM_STR
	,53,	PARAM_AGI
	,54,	PARAM_VIT
	,56,	PARAM_INT
	,58,	PARAM_STR
	,59,	PARAM_LUK
	,60,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_GILOTINCROSS] = JobBonusData;


// アークビショップ
JobBonusData = [
	1,		PARAM_INT
	,3,		PARAM_VIT
	,5,		PARAM_DEX
	,7,		PARAM_INT
	,8,		PARAM_INT
	,10,	PARAM_VIT
	,11,	PARAM_VIT
	,14,	PARAM_DEX
	,15,	PARAM_DEX
	,18,	PARAM_STR
	,19,	PARAM_STR
	,22,	PARAM_INT
	,24,	PARAM_STR
	,26,	PARAM_AGI
	,27,	PARAM_AGI
	,28,	PARAM_STR
	,32,	PARAM_INT
	,34,	PARAM_VIT
	,36,	PARAM_DEX
	,38,	PARAM_AGI
	,39,	PARAM_AGI
	,40,	PARAM_INT
	,41,	PARAM_INT
	,44,	PARAM_DEX
	,45,	PARAM_VIT
	,46,	PARAM_STR
	,49,	PARAM_INT
	,50,	PARAM_DEX
	,51,	PARAM_LUK
	,52,	PARAM_AGI
	,53,	PARAM_VIT
	,54,	PARAM_STR
	,55,	PARAM_INT
	,57,	PARAM_VIT
	,58,	PARAM_LUK
	,59,	PARAM_DEX
	,60,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_ARCBISHOP] = JobBonusData;


// レンジャー
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_INT
	,3,		PARAM_INT
	,4,		PARAM_AGI
	,7,		PARAM_AGI
	,8,		PARAM_DEX
	,9,		PARAM_INT
	,12,	PARAM_VIT
	,13,	PARAM_VIT
	,14,	PARAM_VIT
	,17,	PARAM_DEX
	,18,	PARAM_AGI
	,21,	PARAM_INT
	,22,	PARAM_VIT
	,23,	PARAM_DEX
	,26,	PARAM_STR
	,27,	PARAM_STR
	,30,	PARAM_DEX
	,31,	PARAM_AGI
	,32,	PARAM_VIT
	,36,	PARAM_INT
	,37,	PARAM_INT
	,38,	PARAM_INT
	,39,	PARAM_AGI
	,43,	PARAM_AGI
	,44,	PARAM_DEX
	,45,	PARAM_AGI
	,49,	PARAM_INT
	,50,	PARAM_AGI
	,51,	PARAM_LUK
	,52,	PARAM_DEX
	,54,	PARAM_INT
	,55,	PARAM_AGI
	,57,	PARAM_VIT
	,58,	PARAM_LUK
	,59,	PARAM_DEX
	,60,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_RANGER] = JobBonusData;


// ウォーロック
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_INT
	,3,		PARAM_DEX
	,6,		PARAM_DEX
	,7,		PARAM_INT
	,8,		PARAM_AGI
	,12,	PARAM_INT
	,13,	PARAM_DEX
	,15,	PARAM_VIT
	,18,	PARAM_VIT
	,19,	PARAM_DEX
	,20,	PARAM_AGI
	,23,	PARAM_INT
	,24,	PARAM_VIT
	,25,	PARAM_VIT
	,28,	PARAM_DEX
	,29,	PARAM_AGI
	,31,	PARAM_LUK
	,34,	PARAM_STR
	,35,	PARAM_INT
	,36,	PARAM_INT
	,39,	PARAM_DEX
	,40,	PARAM_AGI
	,41,	PARAM_INT
	,44,	PARAM_INT
	,45,	PARAM_INT
	,47,	PARAM_AGI
	,50,	PARAM_INT
	,51,	PARAM_DEX
	,52,	PARAM_VIT
	,53,	PARAM_LUK
	,54,	PARAM_AGI
	,55,	PARAM_INT
	,57,	PARAM_VIT
	,58,	PARAM_AGI
	,59,	PARAM_DEX
	,60,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_WARLOCK] = JobBonusData;


// メカニック
JobBonusData = [
	1,		PARAM_LUK
	,2,		PARAM_STR
	,5,		PARAM_STR
	,7,		PARAM_LUK
	,8,		PARAM_AGI
	,9,		PARAM_DEX
	,10,	PARAM_INT
	,13,	PARAM_INT
	,14,	PARAM_LUK
	,17,	PARAM_AGI
	,19,	PARAM_VIT
	,20,	PARAM_VIT
	,21,	PARAM_INT
	,22,	PARAM_DEX
	,25,	PARAM_VIT
	,26,	PARAM_LUK
	,29,	PARAM_VIT
	,31,	PARAM_STR
	,32,	PARAM_STR
	,33,	PARAM_VIT
	,34,	PARAM_LUK
	,37,	PARAM_INT
	,38,	PARAM_INT
	,42,	PARAM_VIT
	,43,	PARAM_VIT
	,44,	PARAM_STR
	,45,	PARAM_STR
	,48,	PARAM_DEX
	,49,	PARAM_AGI
	,51,	PARAM_LUK
	,52,	PARAM_STR
	,53,	PARAM_DEX
	,55,	PARAM_INT
	,56,	PARAM_VIT
	,57,	PARAM_AGI
	,59,	PARAM_DEX
	,60,	PARAM_STR
];
G_JOB_BONUS_DATA[JOB_ID_MECHANIC] = JobBonusData;


// ロイヤルガード
JobBonusData = [
	2,		PARAM_VIT
	,3,		PARAM_INT
	,4,		PARAM_STR
	,5,		PARAM_INT
	,6,		PARAM_DEX
	,9,		PARAM_VIT
	,11,	PARAM_INT
	,13,	PARAM_STR
	,14,	PARAM_DEX
	,16,	PARAM_LUK
	,19,	PARAM_INT
	,20,	PARAM_DEX
	,23,	PARAM_AGI
	,24,	PARAM_INT
	,26,	PARAM_INT
	,27,	PARAM_VIT
	,30,	PARAM_STR
	,31,	PARAM_DEX
	,33,	PARAM_LUK
	,34,	PARAM_AGI
	,37,	PARAM_INT
	,38,	PARAM_INT
	,40,	PARAM_STR
	,41,	PARAM_VIT
	,42,	PARAM_VIT
	,44,	PARAM_DEX
	,45,	PARAM_STR
	,46,	PARAM_INT
	,48,	PARAM_STR
	,49,	PARAM_DEX
	,51,	PARAM_AGI
	,53,	PARAM_VIT
	,54,	PARAM_LUK
	,56,	PARAM_DEX
	,58,	PARAM_STR
	,59,	PARAM_VIT
	,60,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_ROYALGUARD] = JobBonusData;


// シャドウチェイサー
JobBonusData = [
	1,		PARAM_LUK
	,2,		PARAM_STR
	,5,		PARAM_STR
	,7,		PARAM_LUK
	,8,		PARAM_AGI
	,9,		PARAM_DEX
	,10,	PARAM_INT
	,13,	PARAM_INT
	,14,	PARAM_LUK
	,17,	PARAM_AGI
	,19,	PARAM_VIT
	,20,	PARAM_VIT
	,21,	PARAM_INT
	,22,	PARAM_DEX
	,25,	PARAM_VIT
	,26,	PARAM_LUK
	,29,	PARAM_VIT
	,31,	PARAM_STR
	,32,	PARAM_STR
	,33,	PARAM_VIT
	,34,	PARAM_LUK
	,37,	PARAM_INT
	,38,	PARAM_INT
	,42,	PARAM_VIT
	,43,	PARAM_VIT
	,44,	PARAM_STR
	,45,	PARAM_STR
	,48,	PARAM_DEX
	,49,	PARAM_AGI
	,51,	PARAM_INT
	,52,	PARAM_VIT
	,53,	PARAM_STR
	,54,	PARAM_AGI
	,56,	PARAM_LUK
	,57,	PARAM_DEX
	,59,	PARAM_STR
	,60,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_SHADOWCHASER] = JobBonusData;


// 修羅
JobBonusData = [
	1,		PARAM_AGI
	,2,		PARAM_DEX
	,4,		PARAM_STR
	,5,		PARAM_STR
	,9,		PARAM_STR
	,10,	PARAM_AGI
	,11,	PARAM_DEX
	,14,	PARAM_VIT
	,15,	PARAM_VIT
	,16,	PARAM_STR
	,19,	PARAM_VIT
	,20,	PARAM_STR
	,23,	PARAM_AGI
	,24,	PARAM_AGI
	,25,	PARAM_DEX
	,28,	PARAM_INT
	,29,	PARAM_INT
	,30,	PARAM_STR
	,31,	PARAM_VIT
	,35,	PARAM_AGI
	,36,	PARAM_DEX
	,37,	PARAM_DEX
	,41,	PARAM_INT
	,42,	PARAM_VIT
	,43,	PARAM_AGI
	,44,	PARAM_AGI
	,48,	PARAM_INT
	,49,	PARAM_DEX
	,50,	PARAM_DEX
	,51,	PARAM_STR
	,53,	PARAM_AGI
	,54,	PARAM_INT
	,55,	PARAM_LUK
	,56,	PARAM_VIT
	,58,	PARAM_DEX
	,59,	PARAM_STR
	,60,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_SHURA] = JobBonusData;


// ミンストレル
JobBonusData = [
	1,		PARAM_INT
	,3,		PARAM_VIT
	,5,		PARAM_DEX
	,7,		PARAM_INT
	,8,		PARAM_INT
	,10,	PARAM_VIT
	,11,	PARAM_VIT
	,14,	PARAM_DEX
	,15,	PARAM_DEX
	,18,	PARAM_STR
	,19,	PARAM_STR
	,22,	PARAM_INT
	,24,	PARAM_STR
	,26,	PARAM_AGI
	,27,	PARAM_AGI
	,28,	PARAM_STR
	,32,	PARAM_INT
	,34,	PARAM_VIT
	,36,	PARAM_DEX
	,38,	PARAM_AGI
	,39,	PARAM_AGI
	,40,	PARAM_INT
	,41,	PARAM_INT
	,44,	PARAM_DEX
	,45,	PARAM_VIT
	,46,	PARAM_STR
	,49,	PARAM_INT
	,50,	PARAM_DEX
	,51,	PARAM_AGI
	,52,	PARAM_VIT
	,53,	PARAM_STR
	,54,	PARAM_LUK
	,56,	PARAM_DEX
	,57,	PARAM_VIT
	,58,	PARAM_STR
	,59,	PARAM_INT
	,60,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_MINSTREL] = JobBonusData;


// ワンダラー
JobBonusData = [
	1,		PARAM_DEX
	,2,		PARAM_INT
	,3,		PARAM_INT
	,4,		PARAM_AGI
	,7,		PARAM_AGI
	,8,		PARAM_DEX
	,9,		PARAM_INT
	,12,	PARAM_VIT
	,13,	PARAM_VIT
	,14,	PARAM_VIT
	,17,	PARAM_DEX
	,18,	PARAM_AGI
	,21,	PARAM_INT
	,22,	PARAM_VIT
	,23,	PARAM_DEX
	,26,	PARAM_STR
	,27,	PARAM_STR
	,30,	PARAM_DEX
	,31,	PARAM_AGI
	,32,	PARAM_VIT
	,36,	PARAM_INT
	,37,	PARAM_INT
	,38,	PARAM_INT
	,39,	PARAM_AGI
	,43,	PARAM_AGI
	,44,	PARAM_DEX
	,45,	PARAM_AGI
	,49,	PARAM_INT
	,50,	PARAM_AGI
	,51,	PARAM_STR
	,52,	PARAM_VIT
	,53,	PARAM_DEX
	,55,	PARAM_LUK
	,56,	PARAM_INT
	,58,	PARAM_VIT
	,59,	PARAM_AGI
	,60,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_WANDERER] = JobBonusData;


// ソーサラー
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_INT
	,3,		PARAM_DEX
	,4,		PARAM_VIT
	,5,		PARAM_INT
	,10,	PARAM_STR
	,11,	PARAM_STR
	,12,	PARAM_INT
	,13,	PARAM_INT
	,14,	PARAM_VIT
	,15,	PARAM_DEX
	,19,	PARAM_DEX
	,20,	PARAM_AGI
	,21,	PARAM_AGI
	,22,	PARAM_INT
	,23,	PARAM_VIT
	,24,	PARAM_DEX
	,30,	PARAM_INT
	,31,	PARAM_DEX
	,32,	PARAM_VIT
	,33,	PARAM_STR
	,39,	PARAM_INT
	,40,	PARAM_DEX
	,41,	PARAM_AGI
	,44,	PARAM_DEX
	,45,	PARAM_VIT
	,46,	PARAM_INT
	,47,	PARAM_LUK
	,48,	PARAM_LUK
	,49,	PARAM_LUK
	,50,	PARAM_INT
	,51,	PARAM_DEX
	,53,	PARAM_STR
	,55,	PARAM_AGI
	,57,	PARAM_VIT
	,59,	PARAM_DEX
	,60,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_SORCERER] = JobBonusData;


// ジェネティック
JobBonusData = [
	1,		PARAM_INT
	,2,		PARAM_INT
	,3,		PARAM_DEX
	,6,		PARAM_DEX
	,7,		PARAM_INT
	,8,		PARAM_AGI
	,12,	PARAM_INT
	,13,	PARAM_DEX
	,15,	PARAM_VIT
	,18,	PARAM_VIT
	,19,	PARAM_DEX
	,20,	PARAM_AGI
	,23,	PARAM_INT
	,24,	PARAM_VIT
	,25,	PARAM_VIT
	,28,	PARAM_DEX
	,29,	PARAM_AGI
	,31,	PARAM_LUK
	,34,	PARAM_STR
	,35,	PARAM_INT
	,36,	PARAM_INT
	,39,	PARAM_DEX
	,40,	PARAM_AGI
	,41,	PARAM_INT
	,44,	PARAM_INT
	,45,	PARAM_INT
	,47,	PARAM_AGI
	,50,	PARAM_INT
	,51,	PARAM_STR
	,52,	PARAM_VIT
	,53,	PARAM_DEX
	,55,	PARAM_AGI
	,56,	PARAM_STR
	,57,	PARAM_VIT
	,58,	PARAM_LUK
	,59,	PARAM_DEX
	,60,	PARAM_INT
];
G_JOB_BONUS_DATA[JOB_ID_GENETIC] = JobBonusData;


// 影狼
JobBonusData = [
	1,		PARAM_DEX
	,3,		PARAM_INT
	,5,		PARAM_AGI
	,6,		PARAM_VIT
	,8,		PARAM_STR
	,9,		PARAM_LUK
	,11,	PARAM_DEX
	,12,	PARAM_STR
	,13,	PARAM_AGI
	,15,	PARAM_INT
	,16,	PARAM_LUK
	,17,	PARAM_VIT
	,21,	PARAM_AGI
	,22,	PARAM_DEX
	,23,	PARAM_STR
	,23,	PARAM_LUK
	,24,	PARAM_VIT
	,25,	PARAM_INT
	,27,	PARAM_DEX
	,29,	PARAM_AGI
	,31,	PARAM_STR
	,32,	PARAM_INT
	,34,	PARAM_DEX
	,35,	PARAM_INT
	,37,	PARAM_VIT
	,38,	PARAM_DEX
	,39,	PARAM_STR
	,41,	PARAM_AGI
	,42,	PARAM_INT
	,43,	PARAM_STR
	,45,	PARAM_DEX
	,46,	PARAM_LUK
	,47,	PARAM_AGI
	,48,	PARAM_STR
	,50,	PARAM_DEX
	,55,	PARAM_AGI
	,60,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_KAGERO] = JobBonusData;


// 朧
JobBonusData = [
	1,		PARAM_DEX
	,3,		PARAM_INT
	,5,		PARAM_AGI
	,6,		PARAM_VIT
	,8,		PARAM_STR
	,9,		PARAM_LUK
	,11,	PARAM_DEX
	,12,	PARAM_STR
	,13,	PARAM_AGI
	,15,	PARAM_INT
	,16,	PARAM_LUK
	,17,	PARAM_VIT
	,21,	PARAM_AGI
	,22,	PARAM_DEX
	,23,	PARAM_STR
	,23,	PARAM_LUK
	,24,	PARAM_VIT
	,25,	PARAM_INT
	,27,	PARAM_DEX
	,29,	PARAM_AGI
	,31,	PARAM_STR
	,32,	PARAM_INT
	,34,	PARAM_DEX
	,35,	PARAM_INT
	,37,	PARAM_VIT
	,38,	PARAM_DEX
	,39,	PARAM_STR
	,41,	PARAM_AGI
	,42,	PARAM_INT
	,43,	PARAM_STR
	,45,	PARAM_DEX
	,46,	PARAM_LUK
	,47,	PARAM_AGI
	,48,	PARAM_STR
	,50,	PARAM_DEX
	,55,	PARAM_AGI
	,60,	PARAM_AGI
];
G_JOB_BONUS_DATA[JOB_ID_OBORO] = JobBonusData;


// スーパーノービス＋
JobBonusData = [
	1,		PARAM_STR
	,2,		PARAM_AGI
	,4,		PARAM_VIT
	,6,		PARAM_INT
	,7,		PARAM_DEX
	,9,		PARAM_LUK
	,11,	PARAM_STR
	,12,	PARAM_AGI
	,14,	PARAM_VIT
	,16,	PARAM_INT
	,17,	PARAM_DEX
	,19,	PARAM_LUK
	,21,	PARAM_STR
	,22,	PARAM_AGI
	,24,	PARAM_VIT
	,26,	PARAM_INT
	,27,	PARAM_DEX
	,29,	PARAM_LUK
	,31,	PARAM_STR
	,32,	PARAM_AGI
	,34,	PARAM_VIT
	,36,	PARAM_INT
	,37,	PARAM_DEX
	,39,	PARAM_LUK
	,41,	PARAM_STR
	,42,	PARAM_AGI
	,44,	PARAM_VIT
	,46,	PARAM_INT
	,47,	PARAM_DEX
	,49,	PARAM_LUK
];
G_JOB_BONUS_DATA[JOB_ID_SUPERNOVICE_PLUS] = JobBonusData;


// リベリオン
JobBonusData = [
	2,		PARAM_DEX
	,4,		PARAM_INT
	,6,		PARAM_VIT
	,7,		PARAM_DEX
	,8,		PARAM_INT
	,9,		PARAM_AGI
	,10,	PARAM_LUK
	,13,	PARAM_VIT
	,14,	PARAM_INT
	,16,	PARAM_AGI
	,17,	PARAM_DEX
	,18,	PARAM_INT
	,19,	PARAM_VIT
	,20,	PARAM_LUK
	,23,	PARAM_VIT
	,24,	PARAM_DEX
	,25,	PARAM_STR
	,26,	PARAM_INT
	,27,	PARAM_AGI
	,30,	PARAM_LUK
	,31,	PARAM_VIT
	,33,	PARAM_DEX
	,34,	PARAM_INT
	,35,	PARAM_STR
	,38,	PARAM_DEX
	,40,	PARAM_AGI
	,41,	PARAM_LUK
	,43,	PARAM_DEX
	,44,	PARAM_VIT
	,45,	PARAM_INT
	,50,	PARAM_STR
	,51,	PARAM_AGI
	,52,	PARAM_LUK
	,54,	PARAM_INT
	,55,	PARAM_DEX
	,57,	PARAM_AGI
	,60,	PARAM_DEX
];
G_JOB_BONUS_DATA[JOB_ID_REBELLION] = JobBonusData;



/**
 * ジョブボーナスを取得する.
 * @param jobId ジョブＩＤ
 * @param jobLv ジョブレベル
 * @return パラメータごとのジョブボーナス配列
 */
function GetJobBonus(jobId, jobLv) {

	var paramArray = [0, 0, 0, 0, 0, 0];

	var idx = 0;

	// ジョブ補正の適用
	for (idx = 0; idx < G_JOB_BONUS_DATA[jobId].length; idx += 2) {
		// 上昇配列のレベル指定が、指定のジョブレベルを超えたら抜ける
		if (G_JOB_BONUS_DATA[jobId][idx] > jobLv) {
			break;
		}

		// 指定のパラメタを上昇させる
		paramArray[ G_JOB_BONUS_DATA[jobId][idx + 1] ]++;
	}

	return paramArray;
}




//================================================================================================
//================================================================================================
//====
//==== 三次職　ＨＰ定義テーブル
//====
//================================================================================================
//================================================================================================
// Lv 90, Lv 91, ... , Lv 99
// Lv100, Lv101, ... , Lv109
//  ...
// Lv160, Lv161, ...
HP_TYPE3 = [

	// ルーンナイト
	 [ 6717, 6863, 7009, 7155, 7301, 7447, 7593, 7739, 7885, 8100,
	   8133, 8242, 8352, 8464, 8576, 8690, 8804, 8920, 9036, 9154,
	   9273, 9393, 9514, 9636, 9759, 9883,10008,10134,10261,10389,
	  10518,10648,10779,10912,11045,11180,11315,11452,11589,11728,
	  11868,12009,12151,12294,12438,12583,12729,12876,13024,13173,
	  13323,13474,13626,13780,13934,14090,14246,14404,14562,14722,
	  14883,15042,15100,15260,15321,15481,15541,15600,15760,15820,
	  15980,16141,16303,16466,16630,16795]

	// ギロチンクロス
	,[ 5029, 5138, 5247, 5356, 5465, 5574, 5683, 5792, 5901, 6050,
	   6093, 6208, 6324, 6441, 6559, 6678, 6798, 6920, 7043, 7167,
	   7292, 7418, 7545, 7673, 7802, 7932, 8063, 8196, 8330, 8465,
	   8601, 8738, 8876, 9015, 9155, 9296, 9438, 9582, 9727, 9873,
	  10020,10168,10317,10467,10618,10770,10923,11078,11234,11391,
	  11549,11708,11868,12029,12191,12354,12518,12684,12851,13019,
	  13188,13351,13518,13684,13850,14016,14182,14349,14515,14681,
	  14830,14966,15103,15241,15380,15520]

	// アークビショップ
	,[ 3609, 3683, 3757, 3831, 3905, 3979, 4053, 4127, 4201, 4300,
	   4333, 4412, 4491, 4570, 4649, 4728, 4807, 4886, 4965, 5044,
	   5123, 5202, 5281, 5360, 5439, 5518, 5597, 5676, 5755, 5834,
	   5913, 5992, 6071, 6150, 6229, 6308, 6387, 6466, 6545, 6624,
	   6703, 6782, 6861, 6940, 7019, 7098, 7177, 7256, 7335, 7414,
	   7493, 7572, 7651, 7730, 7809, 7888, 7967, 8046, 8125, 8204,
	   8283, 8362, 8441, 8520, 8599, 8678, 8757, 8836, 8915, 8994,
	   9115, 9276, 9438, 9601, 9765, 9930]

	// レンジャー
	,[ 4000, 4085, 4170, 4255, 4340, 4425, 4510, 4595, 4680, 4800,
	   4828, 4918, 5009, 5101, 5194, 5288, 5382, 5477, 5573, 5670,
	   5768, 5867, 5967, 6068, 6170, 6273, 6377, 6482, 6588, 6694,
	   6801, 6909, 7018, 7128, 7239, 7351, 7464, 7578, 7693, 7809,
	   7926, 8044, 8162, 8281, 8401, 8522, 8644, 8767, 8891, 9016,
	   9142, 9269, 9397, 9526, 9656, 9786, 9917,10049,10182,10316,
	  10451,10585,10719,10853,10987,11121,11255,11389,11523,11657,
	  11790,11926,12063,12201,12340,12480]

	// ウォーロック
	,[ 2632, 2699, 2765, 2831, 2897, 2963, 3029, 3095, 3161, 3200,
	   3313, 3383, 3455, 3528, 3601, 3675, 3749, 3824, 3899, 3975,
	   4051, 4129, 4208, 4287, 4367, 4447, 4528, 4609, 4691, 4773,
	   4857, 4941, 5026, 5112, 5198, 5285, 5372, 5460, 5548, 5638,
	   5728, 5819, 5911, 6003, 6096, 6189, 6283, 6377, 6473, 6569,
	   6666, 6763, 6861, 6960, 7059, 7159, 7259, 7361, 7463, 7566,
	   7669, 7771, 7874, 7976, 8079, 8181, 8284, 8386, 8489, 8591,
	   8730, 8891, 9053, 9216, 9380, 9545]

	// メカニック
	,[ 4214, 4303, 4392, 4481, 4570, 4659, 4748, 4837, 4926, 5807,
	   5844, 5952, 6061, 6172, 6283, 6396, 6510, 6625, 6741, 6857,
	   6974, 7093, 7212, 7333, 7455, 7578, 7702, 7828, 7954, 8081,
	   8208, 8337, 8467, 8598, 8730, 8864, 8998, 9134, 9271, 9408,
	   9546, 9685, 9825, 9967,10109,10253,10398,10544,10691,10838,
	  10987,11136,11287,11439,11592,11746,11901,12057,12215,12372,
	  12531,12688,12845,13003,13160,13318,13475,13633,13790,13948,
	  14105,14266,14428,14591,14755,14920]

	// ロイヤルガード
	,[ 5029, 5138, 5247, 5356, 5465, 5574, 5683, 5792, 5901, 6050,
	   6093, 6208, 6324, 6441, 6559, 6678, 6798, 6920, 7043, 7167,
	   7292, 7418, 7545, 7673, 7802, 7932, 8063, 8196, 8330, 8465,
	   8601, 8738, 8876, 9015, 9155, 9296, 9438, 9582, 9727, 9873,
	  10020,10168,10317,10467,10618,10770,10923,11078,11234,11391,
	  11549,11708,11868,12029,12191,12354,12518,12684,12851,13019,
	  13188,13355,13522,13690,13857,14025,14192,14360,14527,14695,
	  14860,15021,15183,15346,15510,15675]

	// シャドウチェイサー
	,[ 5029, 5138, 5247, 5356, 5465, 5574, 5683, 5792, 5901, 6050,
	   6093, 6208, 6324, 6441, 6559, 6678, 6798, 6920, 7043, 7167,
	   7292, 7418, 7545, 7673, 7802, 7932, 8063, 8196, 8330, 8465,
	   8601, 8738, 8876, 9015, 9155, 9296, 9438, 9582, 9727, 9873,
	  10020,10168,10317,10467,10618,10770,10923,11078,11234,11391,
	  11549,11708,11868,12029,12191,12354,12518,12684,12851,13019,
	  13188,13300,13420,13500,13600,13700,13800,13900,14000,14100,
	  14200,14301,14403,14506,14610,14715]

	// 修羅
	,[ 4214, 4303, 4392, 4481, 4570, 4659, 4748, 4837, 4926, 5050,
	   5082, 5176, 5271, 5367, 5464, 5562, 5661, 5761, 5862, 5963,
	   6065, 6168, 6272, 6377, 6483, 6590, 6698, 6807, 6917, 7027,
	   7138, 7250, 7363, 7477, 7592, 7708, 7825, 7943, 8062, 8181,
	   8301, 8422, 8544, 8667, 8791, 8916, 9042, 9169, 9297, 9425,
	   9554, 9684, 9815, 9947,10080,10214,10349,10485,10622,10759,
	  10897,11033,11170,11307,11444,11581,11718,11855,11992,12129,
	  12265,12406,12548,12691,12835,12980]

	// ミンストレル
	,[ 4000, 4085, 4170, 4255, 4340, 4425, 4510, 4595, 4680, 4800,
	   4828, 4918, 5009, 5101, 5194, 5288, 5382, 5477, 5573, 5670,
	   5768, 5867, 5967, 6068, 6170, 6273, 6377, 6482, 6588, 6694,
	   6801, 6909, 7018, 7128, 7239, 7351, 7464, 7578, 7693, 7809,
	   7926, 8044, 8162, 8281, 8401, 8522, 8644, 8767, 8891, 9016,
	   9142, 9269, 9397, 9526, 9656, 9786, 9917,10049,10182,10316,
	  10451,10584,10717,10851,10984,11118,11251,11385,11518,11652,
	  11785,11921,12058,12196,12335,12475]

	// ワンダラー
	,[ 4000, 4085, 4170, 4255, 4340, 4425, 4510, 4595, 4680, 4800,
	   4828, 4918, 5009, 5101, 5194, 5288, 5382, 5477, 5573, 5670,
	   5768, 5867, 5967, 6068, 6170, 6273, 6377, 6482, 6588, 6694,
	   6801, 6909, 7018, 7128, 7239, 7351, 7464, 7578, 7693, 7809,
	   7926, 8044, 8162, 8281, 8401, 8522, 8644, 8767, 8891, 9016,
	   9142, 9269, 9397, 9526, 9656, 9786, 9917,10049,10182,10316,
	  10451,10584,10717,10851,10984,11118,11251,11385,11518,11652,
	  11785,11921,12058,12196,12335,12475]

	// ソーサラー
	,[ 3930, 3946, 3962, 3978, 3995, 4012, 4029, 4046, 4063, 4080,
	   4103, 4180, 4257, 4335, 4414, 4494, 4574, 4655, 4737, 4819,
	   4902, 4986, 5071, 5157, 5244, 5332, 5420, 5509, 5599, 5689,
	   5780, 5872, 5965, 6058, 6153, 6248, 6344, 6441, 6539, 6637,
	   6737, 6837, 6937, 7038, 7140, 7243, 7347, 7451, 7557, 7663,
	   7770, 7878, 7987, 8097, 8207, 8318, 8429, 8541, 8654, 8768,
	   8883, 8994, 9107, 9220, 9280, 9340, 9450, 9570, 9680, 9798,
	   9915,10036,10158,10281,10405,10530]

	// ジェネティック
	,[ 3609, 3683, 3757, 3831, 3905, 3979, 4053, 4127, 4201, 4730,
	   4766, 4853, 4940, 5027, 5113, 5200, 5287, 5374, 5461, 5548,
	   5635, 5722, 5809, 5896, 5982, 6069, 6156, 6243, 6330, 6417,
	   6504, 6591, 6678, 6765, 6851, 6938, 7025, 7112, 7199, 7286,
	   7373, 7460, 7547, 7634, 7720, 7807, 7894, 7981, 8068, 8155,
	   8242, 8329, 8416, 8503, 8589, 8676, 8763, 8850, 8937, 9024,
	   9111, 9198, 9285, 9372, 9459, 9546, 9633, 9720, 9807, 9894,
	   9980,10141,10303,10466,10630,10795]
];



/**
 * ＨＰの基礎値を取得する.
 * @param jobId ジョブＩＤ
 * @param baseLv ベースレベル
 * @param bChild 養子フラグ
 */
function GetHPBase(jobId, baseLv, bChild) {

	var nLv = 0;

	// 初めに一般式を仮定
	var maxhp = GetHPBaseSubStandard(jobId, baseLv);

	//----------------------------------------------------------------
	// 特殊計算が必要なケース
	//----------------------------------------------------------------

	// スーパーノービス
	if (jobId == JOB_ID_SUPERNOVICE) {
		// ベースレベル９９なら、ボーナスを追加
		if (baseLv >= 99) {
			maxhp += 2000;
		}
	}

	// スーパーノービス＋
	if (jobId == JOB_ID_SUPERNOVICE_PLUS) {
		// 無条件で、ボーナスを追加
		maxhp += 2000;
	}


	// テコン
	if (jobId == JOB_ID_TAEGWON) {

		// ベースレベル７０以上のみ、専用式
		if (baseLv >= 70) {
			maxhp = 2127;
			for (nLv = 71; nLv <= baseLv; nLv++) {
				// 基本式
				maxhp += 10;
				if (nLv >= 80) maxhp += 10;
				if (nLv >= 82) maxhp += 30;
				if (nLv >= 99) maxhp += 50;

				// 特定レベルでの補正
				if (nLv == 78) maxhp -= 7;
			}
		}
	}

	// ソウルリンカー
	if (jobId == JOB_ID_SOULLINKER) {
		maxhp = 40;

		for (nLv = 2; nLv <= baseLv; nLv++) {
			// 基本式
			maxhp += ROUNDDOWN( (nLv - 2) * 3 / 4 ) + 7;

			// 特定レベルでの補正
			if (nLv >= 71) maxhp -= 40;
			if (nLv >= 81) maxhp -= 10;

			if (nLv == 80) maxhp += 400;
			if (nLv == 85) maxhp += 10;
			if (nLv == 90) maxhp += 490;
			if (nLv == 93) maxhp += 10;
			if (nLv == 98) maxhp += 15;
			if (nLv == 99) maxhp += 421;
		}

	}

	// 拳聖、ガンスリンガー
	if ((jobId == JOB_ID_STARGRADIATOR) || (jobId == JOB_ID_GUNSLINGER)) {

		// ベースレベル７０以上のみ、専用式
		if (baseLv >= 70) {
			if (baseLv <= 79) {
				maxhp = 2670 + 10 * (baseLv - 70);
			}

			else if (baseLv <= 89) {
				maxhp = 3000 + 20 * (baseLv - 80);
			}

			else if (baseLv <= 99) {
				var valAry = [3455,3524,3593,3663,3734,3806,3878,3951,4025,4500];
				maxhp = valAry[baseLv - 90];
			}
		}
	}

	// 忍者
	if (jobId == JOB_ID_NINJA) {
		maxhp = 40;
		for (nLv = 2; nLv <= baseLv; nLv++) {
			maxhp += ROUNDDOWN( (nLv - 2) * 3 / 4 ) + 7;
		}
	}

	// 影狼、朧
	if ((jobId == JOB_ID_KAGERO) || (jobId == JOB_ID_OBORO)) {
		maxhp = 4300;

		for (nLv = 100; nLv <= baseLv; nLv++) {
			maxhp += (nLv - 100) * 2 + 126;

			if (nLv >= 103) {
				if ((nLv - 103) % 4 == 0) {
					maxhp -= 2;
				} else {
					maxhp -= 3;
				}
				maxhp -= ROUNDDOWN( (nLv - 103) / 4 ) * 3;
			}
		}
	}

	// リベリオン
	if(jobId == JOB_ID_REBELLION){
		maxhp = 5180;

		for (nLv = 100; nLv <= baseLv; nLv++) {
			maxhp += ROUNDDOWN(nLv / 2) * 2 + 39;
			maxhp -= ROUNDDOWN( (nLv - 100) / 10);
		}
	}

	// 三次職
	switch (jobId) {
	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:
		maxhp = HP_TYPE3[jobId - JOB_ID_RUNEKNIGHT][baseLv - 90];
	}

	// 転生ボーナス
	if ((bChild == false) && (IsReincarnatedJob(jobId) == true)) {
		maxhp = Math.floor(maxhp * 125 /100);
	}

	// 養子ペナルティ
	if (bChild == true) {
		maxhp = Math.floor(maxhp * 70 / 100);
	}

	return maxhp;
}

/**
 * ＨＰの基礎値を取得する（サブ関数、基本式）.
 * @param jobId ジョブＩＤ
 * @param baseLv ベースレベル
 */
function GetHPBaseSubStandard(jobId, baseLv) {

	var maxhp = 0;
	var hpParamA = 0;
	var hpParamB = 0;

	switch (jobId) {
	case JOB_ID_NOVICE:
		hpParamA = 0;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_SWORDMAN:
		hpParamA = 70;
		hpParamB = 5;
		break;

	case JOB_ID_THIEF:
		hpParamA = 50;
		hpParamB = 5;
		break;

	case JOB_ID_ACOLYTE:
		hpParamA = 40;
		hpParamB = 5;
		break;

	case JOB_ID_ARCHER:
		hpParamA = 50;
		hpParamB = 5;
		break;

	case JOB_ID_MAGICIAN:
		hpParamA = 30;
		hpParamB = 5;
		break;

	case JOB_ID_MARCHANT:
		hpParamA = 40;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_KNIGHT:
		hpParamA = 150;
		hpParamB = 5;
		break;

	case JOB_ID_ASSASIN:
		hpParamA = 110;
		hpParamB = 5;
		break;

	case JOB_ID_PRIEST:
		hpParamA = 75;
		hpParamB = 5;
		break;

	case JOB_ID_HUNTER:
		hpParamA = 85;
		hpParamB = 5;
		break;

	case JOB_ID_WIZARD:
		hpParamA = 55;
		hpParamB = 5;
		break;

	case JOB_ID_BLACKSMITH:
		hpParamA = 90;
		hpParamB = 5;
		break;

	case JOB_ID_CRUSADER:
		hpParamA = 110;
		hpParamB = 7;
		break;

	case JOB_ID_ROGUE:
		hpParamA = 85;
		hpParamB = 5;
		break;

	case JOB_ID_MONK:
		hpParamA = 90;
		hpParamB = 6.5;
		break;

	case JOB_ID_BARD:
		hpParamA = 75;
		hpParamB = 3;
		break;

	case JOB_ID_DANCER:
		hpParamA = 75;
		hpParamB = 3;
		break;

	case JOB_ID_SAGE:
		hpParamA = 75;
		hpParamB = 5;
		break;

	case JOB_ID_ALCHEMIST:
		hpParamA = 90;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_SUPERNOVICE:
		hpParamA = 0;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_LORDKNIGHT:
		hpParamA = 150;
		hpParamB = 5;
		break;

	case JOB_ID_ASSASINCROSS:
		hpParamA = 110;
		hpParamB = 5;
		break;

	case JOB_ID_HIGHPRIEST:
		hpParamA = 75;
		hpParamB = 5;
		break;

	case JOB_ID_SNIPER:
		hpParamA = 85;
		hpParamB = 5;
		break;

	case JOB_ID_HIGHWIZARD:
		hpParamA = 55;
		hpParamB = 5;
		break;

	case JOB_ID_WHITESMITH:
		hpParamA = 90;
		hpParamB = 5;
		break;

	case JOB_ID_PALADIN:
		hpParamA = 110;
		hpParamB = 7;
		break;

	case JOB_ID_CHASER:
		hpParamA = 85;
		hpParamB = 5;
		break;

	case JOB_ID_CHAMPION:
		hpParamA = 90;
		hpParamB = 6.5;
		break;

	case JOB_ID_CROWN:
		hpParamA = 75;
		hpParamB = 3;
		break;

	case JOB_ID_ZYPSY:
		hpParamA = 75;
		hpParamB = 3;
		break;

	case JOB_ID_PROFESSOR:
		hpParamA = 75;
		hpParamB = 5;
		break;

	case JOB_ID_CREATOR:
		hpParamA = 90;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_HI_NOVICE:
		hpParamA = 0;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_HI_SWORDMAN:
		hpParamA = 70;
		hpParamB = 5;
		break;

	case JOB_ID_HI_THIEF:
		hpParamA = 50;
		hpParamB = 5;
		break;

	case JOB_ID_HI_ACOLYTE:
		hpParamA = 40;
		hpParamB = 5;
		break;

	case JOB_ID_HI_ARCHER:
		hpParamA = 50;
		hpParamB = 5;
		break;

	case JOB_ID_HI_MAGICIAN:
		hpParamA = 30;
		hpParamB = 5;
		break;

	case JOB_ID_HI_MARCHANT:
		hpParamA = 40;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_TAEGWON:
		hpParamA = 70;
		hpParamB = 5;
		break;

	case JOB_ID_STARGRADIATOR:
		hpParamA = 90;
		hpParamB = 6.5;
		break;

	case JOB_ID_SOULLINKER:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_NINJA:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_GUNSLINGER:
		hpParamA = 90;
		hpParamB = 6.5;
		break;

	//--------------------------------

	case JOB_ID_RUNEKNIGHT:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_GILOTINCROSS:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_ARCBISHOP:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_RANGER:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_WARLOCK:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_MECHANIC:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_ROYALGUARD:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_SHADOWCHASER:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_SHURA:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_MINSTREL:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_WANDERER:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_SORCERER:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_GENETIC:
		hpParamA = 0;
		hpParamB = 0;
		break;

	//--------------------------------

	case JOB_ID_KAGERO:
		hpParamA = 0;
		hpParamB = 0;
		break;

	case JOB_ID_OBORO:
		hpParamA = 0;
		hpParamB = 0;
		break;

	//--------------------------------

	case JOB_ID_SUPERNOVICE_PLUS:
		hpParamA = 0;
		hpParamB = 5;
		break;

	//--------------------------------

	case JOB_ID_REBELLION:
		hpParamA = 0;
		hpParamB = 0;
		break;

	}


	// ＨＰの基本計算式
	for (var blv = 2; blv <= baseLv; blv++) {
		maxhp += Math.round(hpParamA * blv / 100);
	}
	maxhp = Math.floor((hpParamB * baseLv) + 35 + maxhp);

	return maxhp;
}





//================================================================================================
//================================================================================================
//====
//==== 三次職　ＳＰ定義テーブル
//====
//================================================================================================
//================================================================================================
// Lv 90, Lv 91, ... , Lv 99
// Lv100, Lv101, ... , Lv109
//  ...
// Lv160, Lv161, ...
SP_TYPE3 = [

	// ルーンナイト
	 [ 272, 275, 279, 283, 286, 290, 293, 297, 301, 300,
	   310, 313, 316, 319, 322, 325, 328, 331, 334, 337,
	   340, 343, 346, 349, 352, 355, 358, 361, 364, 367,
	   370, 373, 376, 379, 382, 385, 388, 391, 394, 397,
	   400, 403, 406, 409, 412, 415, 418, 421, 424, 427,
	   430, 433, 436, 439, 442, 445, 448, 451, 454, 457,
	   460, 500, 566, 629, 672, 710, 748, 781, 824, 847,
	   890, 894, 898, 902, 906, 910]

	// ギロチンクロス
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 670, 695, 700, 715, 730, 745, 760, 785, 790,
	   805, 810, 815, 820, 825, 830]

	// アークビショップ
	,[ 728, 736, 744, 752, 760, 769, 777, 785, 793, 800,
	   810, 818, 826, 834, 842, 850, 858, 866, 874, 882,
	   890, 898, 906, 914, 922, 930, 938, 946, 954, 962,
	   970, 978, 986, 994,1002,1010,1018,1026,1034,1042,
	  1050,1058,1066,1074,1082,1090,1098,1106,1114,1122,
	  1130,1138,1146,1154,1162,1170,1178,1186,1194,1202,
	  1210,1258,1286,1334,1372,1410,1458,1466,1474,1482,
	  1490,1499,1508,1517,1526,1535]

	// レンジャー
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 650, 675, 680, 695, 710, 725, 740, 765, 770,
	   785, 790, 795, 800, 805, 810]

	// ウォーロック
	,[ 819, 828, 837, 846, 855, 864, 873, 882, 892, 900,
	   910, 919, 928, 937, 946, 955, 964, 973, 982, 991,
	  1000,1009,1018,1027,1036,1045,1054,1063,1072,1081,
	  1090,1099,1108,1117,1126,1135,1144,1153,1162,1171,
	  1180,1189,1198,1207,1216,1225,1234,1243,1252,1261,
	  1270,1279,1288,1297,1306,1315,1324,1333,1342,1351,
	  1360,1369,1378,1387,1396,1405,1414,1423,1432,1441,
	  1450,1460,1470,1480,1490,1500]

	// メカニック
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 700, 760, 820, 880, 930, 965,1020,1132,1160,
	  1230,1235,1240,1245,1250,1255]

	// ロイヤルガード
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 700, 760, 820, 880, 930, 965,1020,1132,1160,
	  1230,1235,1240,1245,1250,1255]

	// シャドウチェイサー
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 614, 618, 622, 626, 630, 634, 638, 642, 646,
	   650, 655, 660, 665, 670, 675]

	// 修羅
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 614, 618, 622, 626, 630, 634, 638, 642, 646,
	   650, 655, 660, 665, 670, 675]

	// ミンストレル
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 614, 648, 702, 726, 750, 774, 808, 822, 846,
	   850, 855, 860, 865, 870, 875]

	// ワンダラー
	,[ 363, 368, 372, 377, 381, 386, 390, 395, 399, 400,
	   410, 414, 418, 422, 426, 430, 434, 438, 442, 446,
	   450, 454, 458, 462, 466, 470, 474, 478, 482, 486,
	   490, 494, 498, 502, 506, 510, 514, 518, 522, 526,
	   530, 534, 538, 542, 546, 550, 554, 558, 562, 566,
	   570, 574, 578, 582, 586, 590, 594, 598, 602, 606,
	   610, 614, 648, 702, 726, 750, 774, 808, 822, 846,
	   850, 855, 860, 865, 870, 875]

	// ソーサラー
	,[ 819, 828, 837, 846, 855, 864, 873, 882, 892, 900,
	   910, 919, 928, 937, 946, 955, 964, 973, 982, 991,
	  1000,1009,1018,1027,1036,1045,1054,1063,1072,1081,
	  1090,1099,1108,1117,1126,1135,1144,1153,1162,1171,
	  1180,1189,1198,1207,1216,1225,1234,1243,1252,1261,
	  1270,1279,1288,1297,1306,1315,1324,1333,1342,1351,
	  1360,1369,1378,1387,1396,1405,1414,1423,1432,1441,
	  1450,1460,1470,1480,1490,1500]

	// ジェネティック
	,[ 819, 828, 837, 846, 855, 864, 873, 882, 892, 900,
	   910, 919, 928, 937, 946, 955, 964, 973, 982, 991,
	  1000,1009,1018,1027,1036,1045,1054,1063,1072,1081,
	  1090,1099,1108,1117,1126,1135,1144,1153,1162,1171,
	  1180,1189,1198,1207,1216,1225,1234,1243,1252,1261,
	  1270,1279,1288,1297,1306,1315,1324,1333,1342,1351,
	  1360,1369,1378,1387,1396,1405,1414,1423,1432,1441,
	  1450,1460,1470,1480,1490,1500]

];



/**
 * ＳＰの基礎値を取得する.
 * @param jobId ジョブＩＤ
 * @param baseLv ベースレベル
 * @param bChild 養子フラグ
 */
function GetSPBase(jobId, baseLv, bChild) {

	// 初めに一般式を仮定
	var maxsp = GetSPBaseSubStandard(jobId, baseLv);

	//----------------------------------------------------------------
	// 特殊計算が必要なケース
	//----------------------------------------------------------------

	var vartmp = 0;

	// スーパーノービス＋
	if(jobId == JOB_ID_SUPERNOVICE_PLUS) {
		maxsp -= 10;
	}

	// テコン
	if (jobId == JOB_ID_TAEGWON) {

		// マイナス調整補正
		if (baseLv < 70) {
			vartmp = 0;
		}
		else if (baseLv <= 80) {
			vartmp +=  0 - 1 * (baseLv - 70);
		}
		else if (baseLv <= 90) {
			vartmp +=  0 - 1 * (baseLv - 80);
		}
		else {
			vartmp +=  0 - 2 * (baseLv - 90);
		}

		// プラス調整補正
		if (baseLv == 80) vartmp += 10;
		else if (baseLv == 89) vartmp += 9;
		else if (baseLv == 90) vartmp += 10;
		else if (baseLv == 99) vartmp += 10;

		maxsp += vartmp;
	}

	// ソウルリンカー
	if (jobId == JOB_ID_SOULLINKER) {
		if (baseLv < 70) vartmp = 0;
		else if (baseLv < 80) vartmp = (baseLv - 70) * 4 + 5;
		else if (baseLv < 90) vartmp = (baseLv - 80) * 4;
		else if (baseLv < 93) vartmp = (baseLv - 90) * 4;
		else if (baseLv < 99) vartmp = (baseLv - 90) * 4 -10;
		else vartmp = 1;

		maxsp -= vartmp;
	}

	// 拳聖
	if (jobId == JOB_ID_STARGRADIATOR) {

		// ベースレベル７０以上のみ、専用式
		if (baseLv >= 70) {
			if (baseLv <= 79) {
				maxsp = 339 + 2 * (baseLv - 70);
			}

			else if (baseLv <= 89) {
				maxsp = 386 + 2 * (baseLv - 80);
			}

			else if (baseLv <= 98) {
				maxsp = 430 + 3 * (baseLv - 90);
			}

			else {
				maxsp = 500;
			}
		}
	}

	// 忍者
	if(jobId == JOB_ID_NINJA){
		var idx = 0;
		var fracAry = [];

		fracAry[idx++] = 11;
		fracAry[idx++] = Math.max(0, Math.min(20, baseLv - 0)) * 3;
		fracAry[idx++] = Math.max(0, Math.min(20, baseLv - 20)) * 4;
		fracAry[idx++] = Math.max(0, Math.min(20, baseLv - 40)) * 5;
		fracAry[idx++] = Math.max(0, Math.min(20, baseLv - 60)) * 6;
		fracAry[idx++] = Math.max(0, Math.min(20, baseLv - 80)) * 8;
		fracAry[idx++] = baseLv < 80 ? 0 : -1;

		vartmp = 0;
		for (idx = 0; idx < fracAry.length; idx++) {
			vartmp += fracAry[idx];
		}

		maxsp = vartmp;
	}

	// ガンスリンガー
	if(jobId == JOB_ID_GUNSLINGER){
		var idx = 0;
		var fracAry = [];

		fracAry[idx++] = 10;
		fracAry[idx++] = Math.max(0, Math.min(25, baseLv - 0)) * 3;
		fracAry[idx++] = Math.max(0, Math.min(10, baseLv - 25)) * 4;
		fracAry[idx++] = Math.max(0, Math.min( 5, baseLv - 35)) * 3;
		fracAry[idx++] = Math.max(0, Math.min(10, baseLv - 40)) * 4;
		fracAry[idx++] = Math.max(0, Math.min(25, baseLv - 50)) * 5;
		fracAry[idx++] = Math.max(0, Math.min(25, baseLv - 75)) * 6;
		fracAry[idx++] = baseLv < 36 ? 0 : 1;
		fracAry[idx++] = baseLv < 79 ? 0 : 6;

		vartmp = 0;
		for (idx = 0; idx < fracAry.length; idx++) {
			vartmp += fracAry[idx];
		}

		maxsp = vartmp;
	}

	// 影狼、朧
	if ((jobId == JOB_ID_KAGERO) || (jobId == JOB_ID_OBORO)) {

		maxsp = 522 + 8 * (baseLv - 99);

		if(151 <= baseLv){
			var valAry = [958,976,994,1002,1014,1028,1046,1060,1082,1100,1108,1116,1124,1132,1140];
			maxsp = valAry[baseLv - 151];
		}
	}

	// リベリオン
	if (jobId == JOB_ID_REBELLION){

		maxsp = 456 + 6 * (baseLv - 99);

		if (baseLv >= 136) {
			for (var nLv = 136; nLv <= baseLv; nLv++) {
				maxsp += ROUNDDOWN( (nLv - 126) / 10 ) * 2;
			}
		}
	}

	// 三次職
	switch (jobId) {
	case JOB_ID_RUNEKNIGHT:
	case JOB_ID_GILOTINCROSS:
	case JOB_ID_ARCBISHOP:
	case JOB_ID_RANGER:
	case JOB_ID_WARLOCK:
	case JOB_ID_MECHANIC:
	case JOB_ID_ROYALGUARD:
	case JOB_ID_SHADOWCHASER:
	case JOB_ID_SHURA:
	case JOB_ID_MINSTREL:
	case JOB_ID_WANDERER:
	case JOB_ID_SORCERER:
	case JOB_ID_GENETIC:
		maxsp = SP_TYPE3[jobId - JOB_ID_RUNEKNIGHT][baseLv - 90];
	}

	// 転生ボーナス
	if ((bChild == false) && (IsReincarnatedJob(jobId) == true)) {
		maxsp = Math.floor(maxsp * 125 /100);
	}

	// 養子ペナルティ
	if (bChild == true) {
		maxsp = Math.floor(maxsp * 70 / 100);
	}

	return maxsp;
}

/**
 * ＳＰの基礎値を取得する（サブ関数、基本式）.
 * @param jobId ジョブＩＤ
 * @param baseLv ベースレベル
 */
function GetSPBaseSubStandard(jobId, baseLv) {

	var maxsp = 0;
	var spParamA = 0;

	switch (jobId) {
	case JOB_ID_NOVICE:
		spParamA = 1;
		break;

	//--------------------------------

	case JOB_ID_SWORDMAN:
		spParamA = 2;
		break;

	case JOB_ID_THIEF:
		spParamA = 2;
		break;

	case JOB_ID_ACOLYTE:
		spParamA = 5;
		break;

	case JOB_ID_ARCHER:
		spParamA = 2;
		break;

	case JOB_ID_MAGICIAN:
		spParamA = 6;
		break;

	case JOB_ID_MARCHANT:
		spParamA = 3;
		break;

	//--------------------------------

	case JOB_ID_KNIGHT:
		spParamA = 3;
		break;

	case JOB_ID_ASSASIN:
		spParamA = 4;
		break;

	case JOB_ID_PRIEST:
		spParamA = 8;
		break;

	case JOB_ID_HUNTER:
		spParamA = 4;
		break;

	case JOB_ID_WIZARD:
		spParamA = 9;
		break;

	case JOB_ID_BLACKSMITH:
		spParamA = 4;
		break;

	case JOB_ID_CRUSADER:
		spParamA = 4.7;
		break;

	case JOB_ID_ROGUE:
		spParamA = 5;
		break;

	case JOB_ID_MONK:
		spParamA = 4.7;
		break;

	case JOB_ID_BARD:
		spParamA = 6;
		break;

	case JOB_ID_DANCER:
		spParamA = 6;
		break;

	case JOB_ID_SAGE:
		spParamA = 7;
		break;

	case JOB_ID_ALCHEMIST:
		spParamA = 4;
		break;

	//--------------------------------

	case JOB_ID_SUPERNOVICE:
		spParamA = 1;
		break;

	//--------------------------------

	case JOB_ID_LORDKNIGHT:
		spParamA = 3;
		break;

	case JOB_ID_ASSASINCROSS:
		spParamA = 4;
		break;

	case JOB_ID_HIGHPRIEST:
		spParamA = 8;
		break;

	case JOB_ID_SNIPER:
		spParamA = 4;
		break;

	case JOB_ID_HIGHWIZARD:
		spParamA = 9;
		break;

	case JOB_ID_WHITESMITH:
		spParamA = 4;
		break;

	case JOB_ID_PALADIN:
		spParamA = 4.7;
		break;

	case JOB_ID_CHASER:
		spParamA = 5;
		break;

	case JOB_ID_CHAMPION:
		spParamA = 4.7;
		break;

	case JOB_ID_CROWN:
		spParamA = 6;
		break;

	case JOB_ID_ZYPSY:
		spParamA = 6;
		break;

	case JOB_ID_PROFESSOR:
		spParamA = 7;
		break;

	case JOB_ID_CREATOR:
		spParamA = 4;
		break;

	//--------------------------------

	case JOB_ID_HI_NOVICE:
		spParamA = 1;
		break;

	//--------------------------------

	case JOB_ID_HI_SWORDMAN:
		spParamA = 2;
		break;

	case JOB_ID_HI_THIEF:
		spParamA = 2;
		break;

	case JOB_ID_HI_ACOLYTE:
		spParamA = 5;
		break;

	case JOB_ID_HI_ARCHER:
		spParamA = 2;
		break;

	case JOB_ID_HI_MAGICIAN:
		spParamA = 6;
		break;

	case JOB_ID_HI_MARCHANT:
		spParamA = 3;
		break;

	//--------------------------------

	case JOB_ID_TAEGWON:
		spParamA = 2;
		break;

	case JOB_ID_STARGRADIATOR:
		spParamA = 4.7;
		break;

	case JOB_ID_SOULLINKER:
		spParamA = 9;
		break;

	case JOB_ID_NINJA:
		spParamA = 0;
		break;

	case JOB_ID_GUNSLINGER:
		spParamA = 3.75;
		break;

	//--------------------------------

	case JOB_ID_RUNEKNIGHT:
		spParamA = 0;
		break;

	case JOB_ID_GILOTINCROSS:
		spParamA = 0;
		break;

	case JOB_ID_ARCBISHOP:
		spParamA = 0;
		break;

	case JOB_ID_RANGER:
		spParamA = 0;
		break;

	case JOB_ID_WARLOCK:
		spParamA = 0;
		break;

	case JOB_ID_MECHANIC:
		spParamA = 0;
		break;

	case JOB_ID_ROYALGUARD:
		spParamA = 0;
		break;

	case JOB_ID_SHADOWCHASER:
		spParamA = 0;
		break;

	case JOB_ID_SHURA:
		spParamA = 0;
		break;

	case JOB_ID_MINSTREL:
		spParamA = 0;
		break;

	case JOB_ID_WANDERER:
		spParamA = 0;
		break;

	case JOB_ID_SORCERER:
		spParamA = 0;
		break;

	case JOB_ID_GENETIC:
		spParamA = 0;
		break;

	//--------------------------------

	case JOB_ID_KAGERO:
		spParamA = 0;
		break;

	case JOB_ID_OBORO:
		spParamA = 0;
		break;

	//--------------------------------

	case JOB_ID_SUPERNOVICE_PLUS:
		spParamA = 1;
		break;

	//--------------------------------

	case JOB_ID_REBELLION:
		spParamA = 0;
		break;

	}


	// ＳＰの基本計算式
	maxsp = 10 + Math.floor(spParamA * baseLv);

	return maxsp;
}





//================================================================================================
//================================================================================================
//====
//==== インデックス定義
//====
//================================================================================================
//================================================================================================
// 装備部位のインデックス
const_identifier = 0;

EQUIP_REGION_ID_ARMS_RIGHT	 = const_identifier++;
EQUIP_REGION_ID_ARMS_LEFT	 = const_identifier++;
EQUIP_REGION_ID_HEAD_TOP	 = const_identifier++;
EQUIP_REGION_ID_HEAD_MID	 = const_identifier++;
EQUIP_REGION_ID_HEAD_UNDER	 = const_identifier++;
EQUIP_REGION_ID_SHIELD		 = const_identifier++;
EQUIP_REGION_ID_BODY		 = const_identifier++;
EQUIP_REGION_ID_SHOULDER	 = const_identifier++;
EQUIP_REGION_ID_SHOES		 = const_identifier++;
EQUIP_REGION_ID_ACCESSARY_1	 = const_identifier++;
EQUIP_REGION_ID_ACCESSARY_2	 = const_identifier++;
EQUIP_REGION_ID_COSTUME_HEAD_TOP	 = const_identifier++;
EQUIP_REGION_ID_COSTUME_HEAD_MID	 = const_identifier++;
EQUIP_REGION_ID_COSTUME_HEAD_UNDER	 = const_identifier++;

EQUIP_REGION_ID_COUNT		 = const_identifier;
EQUIP_REGION_ID_ANY			 = -1;



// カード部位のインデックス
const_identifier = 0;

CARD_REGION_ID_ARMS_RIGHT_1	 = const_identifier++;
CARD_REGION_ID_ARMS_RIGHT_2	 = const_identifier++;
CARD_REGION_ID_ARMS_RIGHT_3	 = const_identifier++;
CARD_REGION_ID_ARMS_RIGHT_4	 = const_identifier++;
CARD_REGION_ID_ARMS_LEFT_1	 = const_identifier++;
CARD_REGION_ID_ARMS_LEFT_2	 = const_identifier++;
CARD_REGION_ID_ARMS_LEFT_3	 = const_identifier++;
CARD_REGION_ID_ARMS_LEFT_4	 = const_identifier++;
CARD_REGION_ID_HEAD_TOP		 = const_identifier++;
CARD_REGION_ID_HEAD_MID		 = const_identifier++;
CARD_REGION_ID_SHIELD		 = const_identifier++;
CARD_REGION_ID_BODY			 = const_identifier++;
CARD_REGION_ID_SHOULDER		 = const_identifier++;
CARD_REGION_ID_SHOES		 = const_identifier++;
CARD_REGION_ID_ACCESSARY_1	 = const_identifier++;
CARD_REGION_ID_ACCESSARY_2	 = const_identifier++;

const_identifier = 26;

CARD_REGION_ID_ENCHANT_HEAD_TOP_1		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_TOP_2		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_TOP_3		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_MID_1		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_MID_2		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_MID_3		 = const_identifier++;

const_identifier = 33;

CARD_REGION_ID_ENCHANT_HEAD_UNDER_1		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_UNDER_2		 = const_identifier++;
CARD_REGION_ID_ENCHANT_HEAD_UNDER_3		 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHIELD_1			 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHIELD_2			 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHIELD_3			 = const_identifier++;
CARD_REGION_ID_ENCHANT_BODY_1			 = const_identifier++;
CARD_REGION_ID_ENCHANT_BODY_2			 = const_identifier++;
CARD_REGION_ID_ENCHANT_BODY_3			 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHOULDER_1		 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHOULDER_2		 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHOULDER_3		 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHOES_1			 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHOES_2			 = const_identifier++;
CARD_REGION_ID_ENCHANT_SHOES_3			 = const_identifier++;
CARD_REGION_ID_ENCHANT_ACCESSARY_1_1	 = const_identifier++;
CARD_REGION_ID_ENCHANT_ACCESSARY_1_2	 = const_identifier++;
CARD_REGION_ID_ENCHANT_ACCESSARY_1_3	 = const_identifier++;
CARD_REGION_ID_ENCHANT_ACCESSARY_2_1	 = const_identifier++;
CARD_REGION_ID_ENCHANT_ACCESSARY_2_2	 = const_identifier++;
CARD_REGION_ID_ENCHANT_ACCESSARY_2_3	 = const_identifier++;

CARD_REGION_ID_COUNT		 = const_identifier;

const_identifier = -1;

CARD_REGION_ID_ANY						 = const_identifier--;
CARD_REGION_ID_ARMS_RIGHT_ANY			 = const_identifier--;
CARD_REGION_ID_ARMS_LEFT_ANY			 = const_identifier--;
CARD_REGION_ID_HEAD_TOP_ANY				 = const_identifier--;
CARD_REGION_ID_HEAD_MID_ANY				 = const_identifier--;
CARD_REGION_ID_HEAD_UNDER_ANY			 = const_identifier--;
CARD_REGION_ID_SHIELD_ANY				 = const_identifier--;
CARD_REGION_ID_BODY_ANY					 = const_identifier--;
CARD_REGION_ID_SHOULDER_ANY				 = const_identifier--;
CARD_REGION_ID_SHOES_ANY				 = const_identifier--;
CARD_REGION_ID_ACCESSARY_ANY			 = const_identifier--;
CARD_REGION_ID_ACCESSARY_1_ANY			 = const_identifier--;
CARD_REGION_ID_ACCESSARY_2_ANY			 = const_identifier--;







